/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine;

/**
 * All message passing eminating from the engine goes through this interface
 * 
 * @author kjetikl
 */
public interface MessageListener {
    
    /**
     * This method is called when the engine wants to notify potential listeners
     * about an error that has occurred during execution
     * 
     * @param msg A message providing additional human-re information about the error
     * @param errortype A number specifying the type of error that has occurred
     * 
     */
    public void errorMessage(String msg, int errortype);
    
    
    /**
     * This method is called when the engine wants to notify potential listeners
     * about its status in a short and concise way. Status messages should essentially
     * be "one-liners" that could fit in a status bar
     * 
     * @param msg The data itself
     */
    public void statusMessage(String msg);
    
    
    /**
     * This method is called when the engine wants to notify potential listeners
     * about what it is doing and 
     * 
     * @param msg The data itself
     */    
    public void logMessage(String msg);
    

}
