/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine;

import priorseditor.engine.data.Motif;

/**
 * This class contains algorithms to compare a Motif against another Motif or 
 * lists of Motifs
 * 
 * @author kjetikl
 */
public interface MotifComparator {

/** Compares two PWM matrices and returns a score value that reflects their similarity 
 *  The range of the score can be algorithm dependend
 *  The method compares the first motif in direct orientation to the second motif in either the direct or reverse orientation 
 *  @param motifA The first motif
 *  @param motifB The second motif (to be compared with the first)
 *  @param reverseB If this is false motifA will be compared to motifB in the direct orientation,
 *                  If true, motifB will be reverse complemented before comparing it to motifA
 * 
 */    
public double compareMotifs(Motif motifA, Motif motifB, boolean reverseB);



}