/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.data;


/**
 *
 * @author kjetikl
 */
public class DNASequenceDataset extends FeatureDataset {
    private static String typedescription = "DNA sequence dataset";
    
    public DNASequenceDataset(String datasetName) {
        super(datasetName);
    }
   
    @Override
    public void importData(Data source) throws ClassCastException {
        super.importData(source);
        //notifyListenersOfDataUpdate(); 
    }
    
    /** 
     * Returns a deep copy of this object 
     */
    @Override
    public DNASequenceDataset clone() {
        DNASequenceDataset newdataset=new DNASequenceDataset(datasetName); // creates a new dataset with the same name and empty storage
        newdataset.datasetDescription=this.datasetDescription;
        int size=getNumberofSequences();
        for (int i=0;i<size;i++) {
            DNASequenceData seq=(DNASequenceData)getSequenceByIndex(i);
            newdataset.addSequence((DNASequenceData)seq.clone());
        }
        return newdataset;
    }   


    public static String getType() {return typedescription;}

    @Override
    public String getTypeDescription() {return typedescription;}

    @Override
    public boolean containsSameData(Data data) {
        if (data==null || !(data instanceof DNASequenceDataset)) return false;
        DNASequenceDataset other=(DNASequenceDataset)data;
        for (FeatureSequenceData sequence:getAllSequences()) {
            if (!sequence.containsSameData(other.getSequenceByName(sequence.getName()))) return false;
        }
        return false;
    }
}
