/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.data;

/**
 *
 * @author kjetikl
 */
public class NumericConstant extends ConstantData {
    private String name; 
    private Float value;
    private static String typedescription="Numeric constant";
    
    public NumericConstant(String name, float value) {
        this.name=name;
        this.value=new Float(value);
    }
    
    @Override
    public String getName() {return name;}

    @Override
    public void rename(String newname) {
        this.name=newname;
    }     
    
    @Override
    public Float getValue() {return value;}
    
    @Override
    public String getValueAsParameterString() {return ""+value.toString();}
    
    @Override
    public void importData(Data source) throws ClassCastException {
        NumericConstant datasource=(NumericConstant)source;
        this.name=datasource.name;
        this.value=datasource.value;       
        //notifyListenersOfDataUpdate(); 
    }
    
    @Override
    public String getTypeDescription() {return typedescription;}
    

    public static String getType() {return typedescription;}
    
    @Override
    public boolean containsSameData(Data other) {
        if (other==null || !(other instanceof NumericConstant)) return false;
        NumericConstant othernumber=(NumericConstant)other;
        return value.equals(othernumber.value);
    }

    @Override
    public NumericConstant clone() {      
        NumericConstant newdata=new NumericConstant(name, value);
        return newdata;
    }    
}
