/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.data;

import java.util.ArrayList;
import priorseditor.engine.PriorsEditorEngine;
import priorseditor.engine.protocol.ParseError;

/**
 *
 * @author kjetikl
 */
public class NumericVariable extends VariableData {
    private String name; 
    private Float value;
    private static String typedescription="Numeric Variable";
    
    public NumericVariable(String name, float value) {
        this.name=name;
        this.value=new Float(value);
    }
    
    @Override
    public String getName() {return name;}

    @Override
    public void rename(String newname) {
        this.name=newname;
    }     
    
    @Override
    public Float getValue() {return value;}
    
    @Override
    public String getValueAsParameterString() {return ""+value.toString();}

    public void setValue(float newvalue) {
        value=new Float(newvalue);
        notifyListenersOfDataUpdate();
    }
    
    @Override
    public void importData(Data source) throws ClassCastException {
        NumericVariable datasource=(NumericVariable)source;
        this.name=datasource.name;
        this.value=datasource.value;      
        //notifyListenersOfDataUpdate(); 
    }
    
    @Override
    public NumericVariable clone() {      
        NumericVariable newdata=new NumericVariable(name, value);
        return newdata;
    }      

    @Override
    public boolean containsSameData(Data other) {
        if (other==null || !(other instanceof NumericVariable)) return false;
        NumericVariable othernumber=(NumericVariable)other;
        return value.equals(othernumber.value);
    }

    @Override
    public String getTypeDescription() {return typedescription+" = "+value.toString();}
    

    public static String getType() {return typedescription;}

    @Override
    public String output() {
        return value.toString();
    }   
    
    @Override
    public void inputFromPlain(ArrayList<String> input, PriorsEditorEngine engine) throws ParseError {
        if (input==null || input.isEmpty()) throw new ParseError("PLAIN format input for '"+getName()+"' is empty");
        try {
            Float newvalue=Float.parseFloat(input.get(0));
            setValue(newvalue);
        } catch (NumberFormatException nfe) {throw new ParseError("Unable to parse expected numerical input in PLAIN format for "+getName()+": "+nfe.getMessage());}       
    }    
}
