/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.datatracks;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import priorseditor.engine.data.Region;
import priorseditor.engine.data.Sequence;
import java.util.ArrayList;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 *
 * @author kjetikl
 */
public class DASParser_Region {
    SAXParserFactory factory;
    SAXParser saxParser;
    ElementParser handler;
    //char[] buffer=null;
    ArrayList<Region> regionlist;
    int bufferpos=0;    
    String buffer=null;
    int start=Integer.MIN_VALUE;
    int end=Integer.MIN_VALUE;
    int orientation=Sequence.DIRECT;
    float score=Float.MIN_VALUE;
    String label=null;
    
    public ArrayList<Region> parse(String uri, int timeout) throws Exception {
        //System.err.println("Parsing uri:"+uri);
        factory = SAXParserFactory.newInstance();
        saxParser = factory.newSAXParser();
        handler = new ElementParser();
        regionlist=new ArrayList<Region>();
        URL url=new URL(uri);
        URLConnection connection=url.openConnection();
        connection.setConnectTimeout(timeout);
        InputStream inputStream = connection.getInputStream();
        saxParser.parse(inputStream, handler);
        return regionlist;
    } 
    
    /** Implements important methods in the callback interface for the SAX XML-reader*/
    private class ElementParser extends DefaultHandler {
        
        @Override
        public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
            super.startElement(uri, localName, qName, attributes);
            //System.err.println("-> Start:"+localName+","+qName);
            //for (int i=0;i<attributes.getLength();i++) {System.err.println("       "+attributes.getQName(i)+"="+attributes.getValue(i));}         
            if (qName.equals("FEATURE")) {
                start=Integer.MIN_VALUE;
                end=Integer.MIN_VALUE;
                orientation=Sequence.DIRECT;
                score=Float.MIN_VALUE;
                label=attributes.getValue("label");
            }     
            buffer="";
        }
        
        @Override
        public void endElement(String uri, String localName, String qName) throws SAXException {
            super.endElement(uri, localName, qName);
            //System.err.println("<- End  :"+localName+","+qName);
            if (qName.equalsIgnoreCase("START")) {
                try {start=Integer.parseInt(buffer);} catch (NumberFormatException e) {throw new SAXException("Unable to parse expected numeric value = "+buffer);}
            } else if (qName.equalsIgnoreCase("END")) {
                try {end=Integer.parseInt(buffer);} catch (NumberFormatException e) {throw new SAXException("Unable to parse expected numeric value = "+buffer);}
            } else if (qName.equalsIgnoreCase("SCORE")) {
                if (buffer.equals("-")) score=0;
                else try {score=Float.parseFloat(buffer);} catch (NumberFormatException e) {throw new SAXException("Unable to parse expected numeric value = "+buffer);}
            } else if (qName.equalsIgnoreCase("ORIENTATION")) {
                if (buffer.equals("+")) orientation=Region.DIRECT;
                else if (buffer.equals("-")) orientation=Region.REVERSE;
                else orientation=Region.INDETERMINED;
            } else if (qName.equalsIgnoreCase("FEATURE")) {
                regionlist.add(new Region(null, start, end, label, score, orientation));            
            } 
        }


        @Override
        public void characters(char[] ch, int start, int length) throws SAXException {
            super.characters(ch, start, length);
            buffer+=new String(ch, start, length);      
        }
        
        @Override
        public void fatalError(SAXParseException e) throws SAXException {
            super.fatalError(e);
        }
        
    } // end internal class ElementParser
    
    
}
