/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.datatracks;

import java.util.ArrayList;
import java.util.Date;



/**
 *
 * @author kjetikl
 */
public class Server {
    private String serveraddress;
    private int delay=0;
    private Date lastAccessed=null; 
    private ArrayList<String> mirrors=null;
    
    public Server(String serveraddress, int serverdelay) {
        this.serveraddress=serveraddress;
        this.delay=serverdelay;
    }
    
    public String getServerAddress() {
        return serveraddress;
    }
    
    /** 
     * Returns the number of milliseconds one should wait between each successive access to this server 
     * in order to not bog down the server with too many requests at once
     */
    public int getServerDelay() {
        return delay;
    }
    /** Returns  */
    public Date getTimeOfLastAccess() {
        return lastAccessed;
    }
    /** Sets the time of last access for this server  */
    public void setTimeOfLastAccess(Date time) {
        this.lastAccessed=time;
    }
    
    /** 
     * Adds a mirror for this server. The mirror should have the exact same directory structure as
     * the original for relevant files (i.e. the paths to relevant files should be the same for the
     * mirror and the original except for the name of the server itself (and maybe port number)
     */
    public void addMirror(String serveraddress) {
        if (mirrors==null) mirrors=new ArrayList<String>();
        if (!mirrors.contains(serveraddress)) mirrors.add(serveraddress);
    }
    
    /** Returns the server addresses of all mirrors sites for this server */
    public ArrayList<String> getMirrorSites() {
        return mirrors;
    }

     /** Returns an XML element for this DataTrack that can be included in DataConfiguration XML-documents */
    public org.w3c.dom.Element getXMLrepresentation(org.w3c.dom.Document document) {
        org.w3c.dom.Element element = document.createElement("Server");
        element.setAttribute("address", serveraddress);
        element.setAttribute("delay", ""+delay);
        if (mirrors!=null) {
          for (String mirror:mirrors) {
            org.w3c.dom.Element mirrorelement = document.createElement("Mirror");    
            mirrorelement.appendChild(document.createTextNode(mirror));
            element.appendChild(mirrorelement);
          }
        }
        return element;
    }      

}
