/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.operations;

import priorseditor.engine.OperationTask;
import priorseditor.engine.ExecutableTask;
import priorseditor.engine.ExecutionError;
import priorseditor.engine.PriorsEditorClient;
import priorseditor.engine.data.*;

/**
 *
 * @author kjetikl
 */
public class Operation_prompt extends Operation {
    private static final String name="prompt";
    private static final String description="Asks the user to provide a value for a data object";
    private Class[] datasourcePreferences=new Class[]{SequenceCollection.class, NumericVariable.class, BackgroundModel.class, StringVariable.class, StringCollection.class, Motif.class, MotifCollection.class};
    public static final String PROMPT_MESSAGE="PromptMessage";
    
    
    @Override
    public Class[] getDataSourcePreferences() {
        return datasourcePreferences;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public String getName() {
        return name;
    }
    
    @Override
    public String toString() {return name;}
    

    @Override
    public boolean execute(OperationTask task) throws Exception {
        task.checkExecutionLock(); // checks to see if this task should suspend execution
        if (Thread.interrupted() || task.getStatus().equals(ExecutableTask.ABORTED)) throw new InterruptedException();
        String sourceName=task.getSourceDataName();        
        if (sourceName==null || sourceName.isEmpty()) throw new ExecutionError("Missing name for target data object",task.getLineNumber());
        Data sourceData=engine.getDataItem(sourceName);
        if (sourceData==null) throw new ExecutionError("Unable to locate data object '"+sourceName+"'",task.getLineNumber());
        String message=(String)task.getParameter(PROMPT_MESSAGE);      
        Data newDataItem=null;
        PriorsEditorClient client=engine.getClient();
        if (client==null) throw new ExecutionError("System Error: Missing client specification in PROMPT");
        else newDataItem=client.promptValue(sourceData, message);
        if (newDataItem==null) throw new ExecutionError("Got NULL value from client",task.getLineNumber());
        task.checkExecutionLock(); // checks to see if this task should suspend execution
        if (Thread.interrupted() || task.getStatus().equals(ExecutableTask.ABORTED)) throw new InterruptedException();        
        engine.updateDataItem(newDataItem);
        return true;
    }
    
    
    
}
    