/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.protocol;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import priorseditor.engine.operations.Operation;
import priorseditor.engine.OperationTask;
import priorseditor.engine.operations.Operation_prompt;
/**
 *
 * @author kjetikl
 */
public class StandardOperationParser_prompt extends StandardOperationParser {
    

    
    @Override
    public String getCommandString(OperationTask task) {
        String sourceName=task.getSourceDataName();
        String message=(String)task.getParameter(Operation_prompt.PROMPT_MESSAGE);
        String msg="prompt "+sourceName;   
        if (message!=null && !message.isEmpty()) msg+=" \""+message+"\"";
        return msg;
    }

    @Override
    public OperationTask parse(String command) throws ParseError {
           String operationName="prompt";
           String sourceName=null;
           String message=null;

           Pattern pattern=Pattern.compile("^(([a-zA-Z_0-9-]+)\\s*=\\s*)?prompt ([a-zA-Z_0-9-]+)?( \"(.+)\")?(\\s*\\S.*)?");
           Matcher matcher=pattern.matcher(command);
           if (matcher.find()) {
               sourceName=matcher.group(3);
               message=matcher.group(5);
               String unknown=matcher.group(6);
               if (unknown!=null && !unknown.isEmpty()) {
                   throw new ParseError("Unrecognized clause (or wrong order): "+unknown);
               }
               // for (int i=0;i<=matcher.groupCount();i++) System.err.println("Group["+i+"]=>"+matcher.group(i));
           } else throw new ParseError("Unable to parse "+operationName+" command: "+command);
           OperationTask task=new OperationTask(operationName);
           Operation operation=engine.getOperation(operationName);
           if (operation==null) throw new ParseError("SYSTEM ERROR: Missing operation '"+operationName+"'");
           if (sourceName==null || sourceName.isEmpty()) throw new ParseError("Missing name for target data object");
           DataTypeTable lookup=protocol.getDataTypeLookupTable();
           Class sourceclass=lookup.getClassFor(sourceName);
           if (sourceclass==null) throw new ParseError("Unrecognized source object: "+sourceName);
           if (!operation.canUseAsSource(sourceclass)) throw new ParseError("'"+sourceName+"' is of a type not supported by operation '"+operationName+"'");

           task.setParameter(OperationTask.OPERATION, operation);
           task.setParameter(OperationTask.OPERATION_NAME, operationName);
           task.setParameter(OperationTask.TARGET_NAME, sourceName);
           task.setParameter(OperationTask.SOURCE_NAME, sourceName);
           task.setParameter(Operation_prompt.PROMPT_MESSAGE, message);
           return task;
    }

}
