/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import javax.swing.tree.DefaultMutableTreeNode;
import priorseditor.engine.data.Motif;

/**
 *
 * @author kjetikl
 */
public class CheckBoxTreeNode extends DefaultMutableTreeNode {
    private boolean processed=false;
    private boolean checked=true;
    private static VisualizationSettings settings;
    
    public static void setVisualizationSettings(VisualizationSettings s) {settings=s;}
    
    public CheckBoxTreeNode(Object userObject) {
        super(userObject);
    }
    
    public CheckBoxTreeNode(Object userObject, boolean allowsChildren) {
        super(userObject, allowsChildren);
    }

    public boolean isChecked() {
       if (userObject instanceof Motif) return settings.isVisible(getName());
       else return checked;
    }
    
    public void setChecked(boolean checkedvalue) {
        if (userObject instanceof Motif) settings.setFeatureVisible(getName(),checkedvalue,false);
        else checked=checkedvalue;
    }
    
    public boolean isProcessed() {
       return processed;
    }
    
    public void setProcessed(boolean processedvalue) {
        this.processed=processedvalue;
    }
    
    public String getName() {
        if (userObject==null) return "empty";
        else return userObject.toString();
    }
    
    public String toString() {
        return getName();
    }
}

