/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;
import java.awt.Color;
import java.io.Serializable;
/**
 * Creates a gradient with a range of colors between the first and second given color
 * 
 * @author kjetikl
 */
public class ColorGradient implements Serializable{
    Color gradient[]= new Color[101];
    
    /**
     * Creates a new color gradient consisting of 100 color shades between
     * the specified target and background color
     * @param targetcolor
     * @param background
     */
    public ColorGradient(Color targetcolor,Color background) {
        float col1_rgb[];
        float col2_rgb[];
        col1_rgb = background.getRGBComponents(null);
        col2_rgb = targetcolor.getRGBComponents(null);
        float diff_r=(col2_rgb[0]-col1_rgb[0])/100.0f;
        float diff_g=(col2_rgb[1]-col1_rgb[1])/100.0f;
        float diff_b=(col2_rgb[2]-col1_rgb[2])/100.0f;
        for (int i=0;i<=100;i++) {
            //System.out.println("Creating new color r="+(col1_rgb[0]+diff_r*i)+", g="+(col1_rgb[1]+diff_g*i)+", b="+(col1_rgb[2]+diff_b*i));
            gradient[i]=new Color(col1_rgb[0]+diff_r*i,col1_rgb[1]+diff_g*i,col1_rgb[2]+diff_b*i);
            //gradient[i]=Color.red;
        }
    }
    
  /**
   * Returns the color for a given value which should be and integer between 0 and 100
   * @param value
   */
    public Color getColor(int value) {
        if (value>100) {value=100;} 
        else if (value<0) {value=0;}
        return gradient[value];
    }
     
  /**
   * Returns the color for a given value which should be and a float between 0.0 and 1.0
   * @param value
   */
    public Color getColor(float value) {
        int i=Math.round(value*100);
        if (i>100) {i=100;} 
        else if (i<0) {i=0;}
        return gradient[i];
    }
    
    /**
     * Returns the foreground color associated with this gradient (highest color)
     * @return foreground color
     */
    public Color getForegroundColor() {
        return gradient[100];
    }
    
    /**
     * Returns the background color associated with this gradient (lowest color)
     * @return foreground color
     */
    public Color getBackgroundColor() {
        return gradient[0];
    }
}
