/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ExternalProgramAddFromRepositoryDialog.java
 *
 * Created on 01.jul.2010, 15:25:35
 */

package priorseditor.gui;

import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.InputStream;
import java.net.URL;
import java.util.HashMap;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import priorseditor.engine.SystemError;

/**
 *
 * @author kjetikl
 */
public class ExternalProgramAddFromRepositoryDialog extends javax.swing.JDialog {
    private JTable programsTable;
    private DefaultTableModel tablemodel;
    private boolean installButtonClicked=false;
    private HashMap<String,String> descriptions=new HashMap<String,String>();
    private HashMap<String,String> URLs=new HashMap<String,String>();
    private URL repositoryURL=null;
    private PriorsEditorGUI gui;

    /** Creates new form ExternalProgramAddFromRepositoryDialog */
    public ExternalProgramAddFromRepositoryDialog(PriorsEditorGUI pegui) {
        super(pegui.getFrame(), "External Programs Repository", true);
        this.gui=pegui;
        initComponents();
        try {
            repositoryURL=new URL("http://tare.medisin.ntnu.no/priorseditor/toolsrepository.xml");
        } catch (Exception e) {}
        tablemodel=new DefaultTableModel(new String[]{"Name","Type","Available sources","Requirements"},0);
        programsTable=new JTable(tablemodel) {
            @Override
            public boolean isCellEditable(int row, int col) {
                return false;
            }
        };
        programsTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        programsTable.setRowSelectionAllowed(true);
        programsTable.setColumnSelectionAllowed(false);
        //programsTable.setFillsViewportHeight(true);
        programsTable.getTableHeader().setReorderingAllowed(false);
        //programsTable.setRowHeight(18);
        programsTable.setAutoCreateRowSorter(true);
        programsTable.getRowSorter().toggleSortOrder(0);
        scrollPane.setViewportView(programsTable);
        programsTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                installButton.setEnabled(programsTable.getSelectedRow()>=0);
            }
        });
        programsTable.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
               super.mouseClicked(e);
               if (e.getClickCount()<2) return;
               installButton.doClick();
            }
        });
        Dimension d=new Dimension(650,500);
        this.setMinimumSize(d);
        this.setPreferredSize(d);
        SwingWorker<Boolean, Void> worker=new SwingWorker<Boolean, Void>() {
            Exception ex=null;
            @Override
            public Boolean doInBackground() {
                try {
                   populateList();
                }
                catch (Exception e) {ex=e;}
                return Boolean.TRUE;
            }
            @Override
            public void done() { // this method is invoked on the EDT!
                if (ex!=null) {
                    JOptionPane.showMessageDialog(gui.getFrame(), ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
        }; // end of SwingWorker class
        worker.execute();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        cancelButton = new javax.swing.JButton();
        installButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(400, 20));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 20, Short.MAX_VALUE)
        );

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_START);

        jPanel2.setMaximumSize(new java.awt.Dimension(32767, 40));
        jPanel2.setMinimumSize(new java.awt.Dimension(100, 40));
        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(400, 40));

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(ExternalProgramAddFromRepositoryDialog.class);
        cancelButton.setText(resourceMap.getString("cancelButton.text")); // NOI18N
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonClicked(evt);
            }
        });

        installButton.setText(resourceMap.getString("installButton.text")); // NOI18N
        installButton.setEnabled(false);
        installButton.setName("installButton"); // NOI18N
        installButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                installButtonClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(250, Short.MAX_VALUE)
                .addComponent(installButton)
                .addGap(10, 10, 10)
                .addComponent(cancelButton)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(installButton)
                    .addComponent(cancelButton))
                .addContainerGap())
        );

        getContentPane().add(jPanel2, java.awt.BorderLayout.PAGE_END);

        jPanel3.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 10, 1, 10));
        jPanel3.setName("jPanel3"); // NOI18N
        jPanel3.setLayout(new java.awt.BorderLayout());

        scrollPane.setName("scrollPane"); // NOI18N
        jPanel3.add(scrollPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel3, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonClicked
        // TODO add your handling code here:
        setVisible(false);
    }//GEN-LAST:event_cancelButtonClicked

    private void installButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_installButtonClicked
        // TODO add your handling code here:
        installButtonClicked=true;
        setVisible(false);
    }//GEN-LAST:event_installButtonClicked


    /** Returns the URL pointing to the XML-config file for the selected program
     * (or NULL if no program was selected)
     */
    public String getURL() {
        if (!installButtonClicked) return null;
        int row=programsTable.getSelectedRow();
        if (row<0) return null;
        int modelrow=programsTable.convertRowIndexToModel(row);
        String programName=(String)tablemodel.getValueAt(modelrow, 0);
        return URLs.get(programName);

    }
    /** Returns name of the selected program
     * (or NULL if no program was selected)
     */
    public String getProgramName() {
        if (!installButtonClicked) return null;
        int row=programsTable.getSelectedRow();
        if (row<0) return null;
        int modelrow=programsTable.convertRowIndexToModel(row);
        String programName=(String)tablemodel.getValueAt(modelrow, 0);
        return programName;

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton installButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

    /** Populates the tablemodel with entries from the repositoryURL */
    private void populateList() throws Exception {
         URLs.clear();
         descriptions.clear();
         if (repositoryURL==null) throw new SystemError("Repository URL==null!");
         InputStream repositoryStream=repositoryURL.openStream();
         DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
         Document doc = builder.parse(repositoryStream);
         NodeList programnodes = doc.getElementsByTagName("program");
         for (int i=0;i<programnodes.getLength();i++) {
             Element programNode = (Element)programnodes.item(i);
            
             String programName=programNode.getAttribute("name");
             if (programName==null || programName.isEmpty()) throw new SystemError("Repository Error: Missing name for program #"+(i+1));
            
             String programType=programNode.getAttribute("class");
             if (programType==null || programType.isEmpty()) throw new SystemError("Repository Error: Missing type specification for program '"+programName+"'");
            
             String programURL=programNode.getAttribute("URL");
             if (programURL==null || programURL.isEmpty()) throw new SystemError("Repository Error: Missing URL specification for program '"+programName+"'");
             String programRequirements=programNode.getAttribute("requirements");
             String programSources=programNode.getAttribute("sources");
             String programDescription=programNode.getTextContent();
             URLs.put(programName, programURL);
             descriptions.put(programDescription, programURL);
             final Object[] newrow=new Object[]{programName,programType,programSources,programRequirements};
             //System.err.println("Adding:"+programName+"["+programType+"] "+programSources+"   :   "+programRequirements+"  :  "+programDescription);
             Runnable runner=new Runnable() {
                @Override
                public void run() {
                    tablemodel.addRow(newrow);
                    programsTable.repaint();
                }
             };
             SwingUtilities.invokeLater(runner);
         }
    }


}
