/*
 * InfoDialog.java
 *
 * Created on 11. februar 2010, 10:53
 */

package priorseditor.gui;

import java.awt.Dimension;

/**
 * This class represents a general information dialog that can be
 * used to display documents (possibly in HTML format) in a popup dialog window.
 * The dialog also contains a single "OK" button that can be used to dispose of the window
 * 
 * @author  kjetikl
 */
public class InfoDialog extends javax.swing.JDialog {

    /** Creates new form InfoDialog with standard size 750x600*/
    public InfoDialog(java.awt.Frame parent, String title, String document) {
        this(parent,title,document,750,600);
    }
    
    /** Creates new form InfoDialog with given size*/
    public InfoDialog(java.awt.Frame parent, String title, String document, int width, int height) {
        super(parent, title, true);
        initComponents();
        documentPane.setContentType("text/html");
        documentPane.setText(document);      
        documentPane.setCaretPosition(0);
        documentPane.setFocusable(true);
        documentPane.setEditable(false);
        getRootPane().setDefaultButton(okButton);
        Dimension d=new Dimension(width,height);        
        this.setPreferredSize(d);
        this.setLocation((parent.getWidth()-d.width)/2, (parent.getHeight()-d.height)/2);
        pack();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        topPanel = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        documentPane = new javax.swing.JEditorPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(100, 40));

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(InfoDialog.class);
        okButton.setText(resourceMap.getString("okButton.text")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonClicked(evt);
            }
        });
        jPanel1.add(okButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);

        topPanel.setName("topPanel"); // NOI18N
        topPanel.setPreferredSize(new java.awt.Dimension(100, 10));

        javax.swing.GroupLayout topPanelLayout = new javax.swing.GroupLayout(topPanel);
        topPanel.setLayout(topPanelLayout);
        topPanelLayout.setHorizontalGroup(
            topPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        topPanelLayout.setVerticalGroup(
            topPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 10, Short.MAX_VALUE)
        );

        getContentPane().add(topPanel, java.awt.BorderLayout.PAGE_START);

        jPanel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(8, 8, 8, 8));
        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        documentPane.setEditable(false);
        documentPane.setName("documentPane"); // NOI18N
        jScrollPane1.setViewportView(documentPane);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void okButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonClicked
// TODO add your handling code here:
    setVisible(false);//GEN-LAST:event_okButtonClicked
}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JEditorPane documentPane;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton okButton;
    private javax.swing.JPanel topPanel;
    // End of variables declaration//GEN-END:variables

}
