/*
 * LicenseAgreementDialog.java
 *
 * Created on 22. februar 2010, 12:05
 */

package priorseditor.gui;

import java.awt.Dimension;

/**
 *
 * @author  kjetikl
 */
public class LicenseAgreementDialog extends javax.swing.JDialog {
    
    /** Creates new form LicenseAgreementDialog */
    public LicenseAgreementDialog(java.awt.Frame parent, String license) {
        super(parent, true);
        initComponents();
        licensePane.setContentType("text/html");
        licensePane.setText(license);      
        licensePane.setCaretPosition(0);
        licensePane.setFocusable(false);
        getRootPane().setDefaultButton(okButton);
        Dimension d=new Dimension(600,400);        
        this.setPreferredSize(d);
        this.setLocation((parent.getWidth()-d.width)/2, (parent.getHeight()-d.height)/2);
        pack();      
    }
    /** Creates new form LicenseAgreementDialog with dialog title*/
    public LicenseAgreementDialog(java.awt.Frame parent, String dialogtitle, String license) {
        super(parent, dialogtitle, true);
        initComponents();
        licensePane.setContentType("text/html");
        licensePane.setText(license);      
        licensePane.setCaretPosition(0);
        licensePane.setFocusable(false);
        getRootPane().setDefaultButton(okButton);
        Dimension d=new Dimension(600,400);        
        this.setPreferredSize(d);
        this.setLocation((parent.getWidth()-d.width)/2, (parent.getHeight()-d.height)/2);
        pack(); 
    }
    
    /** Returns true if the license agreement has been accepted */
    public boolean isLicenseAccepted() {
        return agreeYes.isSelected();
    }
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        toplabel1 = new javax.swing.JLabel();
        toplabel2 = new javax.swing.JLabel();
        mainpanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        licensePane = new javax.swing.JEditorPane();
        buttonspanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        agreeNo = new javax.swing.JRadioButton();
        agreeYes = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(LicenseAgreementDialog.class);
        jPanel2.setBackground(resourceMap.getColor("jPanel2.background")); // NOI18N
        jPanel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        toplabel1.setFont(resourceMap.getFont("toplabel1.font")); // NOI18N
        toplabel1.setText(resourceMap.getString("toplabel1.text")); // NOI18N
        toplabel1.setName("toplabel1"); // NOI18N
        jPanel2.add(toplabel1);

        toplabel2.setText(resourceMap.getString("toplabel2.text")); // NOI18N
        toplabel2.setName("toplabel2"); // NOI18N
        jPanel2.add(toplabel2);

        getContentPane().add(jPanel2, java.awt.BorderLayout.PAGE_START);

        mainpanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 10, 10));
        mainpanel.setName("mainpanel"); // NOI18N
        mainpanel.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        licensePane.setEditable(false);
        licensePane.setName("licensePane"); // NOI18N
        licensePane.setPreferredSize(new java.awt.Dimension(450, 300));
        jScrollPane1.setViewportView(licensePane);

        mainpanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(mainpanel, java.awt.BorderLayout.CENTER);

        buttonspanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 10, 2, 10));
        buttonspanel.setMinimumSize(new java.awt.Dimension(103, 40));
        buttonspanel.setName("buttonspanel"); // NOI18N
        buttonspanel.setLayout(new javax.swing.BoxLayout(buttonspanel, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel4.setName("jPanel4"); // NOI18N
        jPanel4.setLayout(new java.awt.GridBagLayout());

        buttonGroup1.add(agreeNo);
        agreeNo.setSelected(true);
        agreeNo.setText(resourceMap.getString("agreeNo.text")); // NOI18N
        agreeNo.setName("agreeNo"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(agreeNo, gridBagConstraints);

        buttonGroup1.add(agreeYes);
        agreeYes.setText(resourceMap.getString("agreeYes.text")); // NOI18N
        agreeYes.setName("agreeYes"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(agreeYes, gridBagConstraints);

        jPanel1.add(jPanel4);

        buttonspanel.add(jPanel1);

        jPanel3.setName("jPanel3"); // NOI18N
        jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        okButton.setText(resourceMap.getString("okButton.text")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.setPreferredSize(new java.awt.Dimension(65, 27));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonClicked(evt);
            }
        });
        jPanel3.add(okButton);

        buttonspanel.add(jPanel3);

        getContentPane().add(buttonspanel, java.awt.BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void okButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonClicked
    setVisible(false);//GEN-LAST:event_okButtonClicked
}


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton agreeNo;
    private javax.swing.JRadioButton agreeYes;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JPanel buttonspanel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JEditorPane licensePane;
    private javax.swing.JPanel mainpanel;
    private javax.swing.JButton okButton;
    private javax.swing.JLabel toplabel1;
    private javax.swing.JLabel toplabel2;
    // End of variables declaration//GEN-END:variables

}
