/*
 * MotifBrowser.java
 *
 * Created on 12. april 2010, 15:22
 */

package priorseditor.gui;

import java.awt.Dimension;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;
import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JTable;
import javax.swing.border.Border;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.RowSorterEvent;
import javax.swing.event.RowSorterListener;
import javax.swing.table.TableModel;
import priorseditor.engine.data.Data;
import priorseditor.engine.data.Motif;

/**
 *
 * @author  kjetikl
 */
public class MotifBrowser extends javax.swing.JDialog implements ListSelectionListener, RowSorterListener, WindowListener {
    private static String VISUALIZE_SHOWN="Visualize shown motifs only";
    private static String VISUALIZE_SELECTED="Visualize selected motifs only";
    
   private MotifBrowserPanel motifbrowser;
    private JTable table;
    private TableModel model;
    private VisualizationSettings settings;
    private PriorsEditorGUI gui;

    /** Creates new form MotifBrowser */
    public MotifBrowser(PriorsEditorGUI gui) {
        super(gui.getFrame(), false);
        this.gui=gui;
        initComponents();
        Border emptyBorder=BorderFactory.createEmptyBorder(10,6,0,6);
        motifbrowser=new MotifBrowserPanel(gui,null);
        gui.getEngine().addDataListener(motifbrowser);
        Dimension size=new Dimension(580,500);
        motifbrowser.setPreferredSize(size);
        motifbrowser.setBorder(BorderFactory.createCompoundBorder(emptyBorder, BorderFactory.createRaisedBevelBorder()));
        this.add(motifbrowser);
        pack();
        getRootPane().setDefaultButton(closeButton);
        table=motifbrowser.getTable();
        model=table.getModel();
        table.getRowSorter().addRowSorterListener(this);
        table.getSelectionModel().addListSelectionListener(this);
        settings=gui.getVisualizationSettings();
        visualizefilterCombobox.setModel(new DefaultComboBoxModel(new String[]{"",VISUALIZE_SHOWN,VISUALIZE_SELECTED}));
        this.addWindowListener(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        visualizefilterCombobox = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(MotifBrowser.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N

        jPanel1.setMinimumSize(new java.awt.Dimension(100, 40));
        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(100, 40));

        closeButton.setText(resourceMap.getString("closeButton.text")); // NOI18N
        closeButton.setMaximumSize(new java.awt.Dimension(75, 27));
        closeButton.setMinimumSize(new java.awt.Dimension(75, 27));
        closeButton.setName("closeButton"); // NOI18N
        closeButton.setOpaque(false);
        closeButton.setPreferredSize(new java.awt.Dimension(75, 27));
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonClicked(evt);
            }
        });

        visualizefilterCombobox.setMinimumSize(new java.awt.Dimension(220, 27));
        visualizefilterCombobox.setName("visualizefilterCombobox"); // NOI18N
        visualizefilterCombobox.setPreferredSize(new java.awt.Dimension(220, 27));
        visualizefilterCombobox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                visualizefilterchanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(visualizefilterCombobox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 85, Short.MAX_VALUE)
                .addComponent(closeButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(closeButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(visualizefilterCombobox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void closeButtonClicked(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonClicked
// TODO add your handling code here:
    
    setVisible(false);//GEN-LAST:event_closeButtonClicked
    getContentPane().removeAll(); // this will release some resources
    this.dispose();
}


private void visualizefilterchanged(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_visualizefilterchanged
      updateVisualization();    
       String selection=(String)visualizefilterCombobox.getSelectedItem();//GEN-LAST:event_visualizefilterchanged
}

    @Override
    public void valueChanged(ListSelectionEvent e) {
        updateVisualization();
    }

    @Override
    public void sorterChanged(RowSorterEvent e) {
        table.clearSelection();
        updateVisualization();
    }

   /** Hides or shows motifs according to specification */
    private void updateVisualization() {
         String selection=(String)visualizefilterCombobox.getSelectedItem();
         if (selection.equals(VISUALIZE_SHOWN)) {
             motifbrowser.setVisibilityOnAllMotifs(false);
             int size=table.getRowCount();
             for (int i=0;i<size;i++) {
                 int row=table.convertRowIndexToModel(i);
                 Motif motif=(Motif)model.getValueAt(row, 1);
                 settings.setFeatureVisible(motif.getName(), true, false);
             }
         } else if (selection.equals(VISUALIZE_SELECTED)) {
             motifbrowser.setVisibilityOnAllMotifs(false);
             int[] selected = table.getSelectedRows();
             for (int row:selected) {
                 int modelrow=table.convertRowIndexToModel(row);
                 Motif motif=(Motif)model.getValueAt(modelrow, 1);
                 settings.setFeatureVisible(motif.getName(), true, false);
             }
         } else {
            return;
         }
        settings.redraw();
        gui.getMotifsPanel().repaint();
    }

    @Override
    public void windowActivated(WindowEvent e) { }

    @Override
    public void windowClosed(WindowEvent e) {
        gui.getEngine().removeDataListener(motifbrowser);
    }

    @Override
    public void windowClosing(WindowEvent e) { }

    @Override
    public void windowDeactivated(WindowEvent e) {}

    @Override
    public void windowDeiconified(WindowEvent e) {}

    @Override
    public void windowIconified(WindowEvent e) { }

    @Override
    public void windowOpened(WindowEvent e) {}




    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JComboBox visualizefilterCombobox;
    // End of variables declaration//GEN-END:variables

}
