/*
 * MotifClassDialog.java
 *
 * Created on 24. juli 2009, 19:42
 */

package priorseditor.gui;

import java.awt.Component;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import org.jdesktop.application.Action;
import priorseditor.engine.data.MotifClassification;

/**
 *
 * @author  kjetikl
 */
public class MotifClassDialog extends javax.swing.JDialog {
    private String selectedClass;
    private boolean okClicked=false;
    
    /** Creates new form MotifClassDialog */
    public MotifClassDialog(java.awt.Frame parent, String currentClass) {
        super(parent, true);
        selectedClass=currentClass;
        initComponents();
        setTitle("Select motif class");
        classTree.setModel(MotifClassification.getClassTreeModel()); 
        classTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        classTree.setCellRenderer(new MotifClassTreeCellRenderer());
        getRootPane().setDefaultButton(OKButton);
        classTree.setRootVisible(false);
        if (selectedClass==null) classTree.setSelectionRow(0);
        else {
            TreePath path=new TreePath(MotifClassification.getPathToClass((DefaultMutableTreeNode)classTree.getModel().getRoot(),selectedClass));
            classTree.expandPath(path.getParentPath());
            classTree.setSelectionPath(path);
        }
    }
    
    public boolean isOKClicked() {
        return okClicked;
    }
    
    public String getSelectedClass() {
        return selectedClass;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        cancelButton = new javax.swing.JButton();
        OKButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        classTree = new javax.swing.JTree();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(400, 400));
        setName("Form"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(100, 50));

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getActionMap(MotifClassDialog.class, this);
        cancelButton.setAction(actionMap.get("cancelAction")); // NOI18N
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(MotifClassDialog.class);
        cancelButton.setText(resourceMap.getString("cancelButton.text")); // NOI18N
        cancelButton.setMaximumSize(new java.awt.Dimension(68, 25));
        cancelButton.setMinimumSize(new java.awt.Dimension(68, 25));
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.setPreferredSize(new java.awt.Dimension(68, 25));

        OKButton.setAction(actionMap.get("okAction")); // NOI18N
        OKButton.setText(resourceMap.getString("OKButton.text")); // NOI18N
        OKButton.setMaximumSize(new java.awt.Dimension(68, 25));
        OKButton.setMinimumSize(new java.awt.Dimension(68, 25));
        OKButton.setName("OKButton"); // NOI18N
        OKButton.setPreferredSize(new java.awt.Dimension(68, 25));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(255, Short.MAX_VALUE)
                .addComponent(OKButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(14, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(OKButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);

        jPanel2.setBorder(javax.swing.BorderFactory.createEmptyBorder(10, 10, 0, 10));
        jPanel2.setName("jPanel2"); // NOI18N
        jPanel2.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        classTree.setName("classTree"); // NOI18N
        jScrollPane1.setViewportView(classTree);

        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    @Action
    public void cancelAction() {
        okClicked=false;
        setVisible(false);
    }

    @Action
    public void okAction() {
        DefaultMutableTreeNode node=(DefaultMutableTreeNode)classTree.getSelectionPath().getLastPathComponent();
        selectedClass=(String)node.getUserObject();
        okClicked=true;
        setVisible(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton OKButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JTree classTree;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables


private class MotifClassTreeCellRenderer extends DefaultTreeCellRenderer {

   public MotifClassTreeCellRenderer() {
     super();
   }
    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean isSelected,boolean expanded,boolean leaf, int row,boolean hasFocus) {
        DefaultMutableTreeNode node=(DefaultMutableTreeNode)value;
        Object uservalue=node.getUserObject();
        if (uservalue==null) setText("UNKNOWN CLASS");
        else {
           String classString=uservalue.toString();
           setText(classString+" : "+MotifClassification.getNameForClass(classString));
        }
        if (isSelected) setForeground(java.awt.Color.WHITE);
        else setForeground(java.awt.Color.BLACK);
        if (leaf) setIcon(null);
        else if (expanded) setIcon(getOpenIcon());
        else  setIcon(getClosedIcon());
        return this;
    }

}

}
