/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import java.awt.event.ActionEvent;
import priorseditor.engine.PriorsEditorEngine;
import priorseditor.engine.operations.Operation;
import priorseditor.engine.OperationTask;
import priorseditor.engine.data.Data;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JList;
import java.awt.event.ActionListener;
import javax.swing.DefaultListModel;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Collections;



/**
 *
 * @author kjetikl
 */
public class OperationsPanelContextMenu extends JPopupMenu {
    private PriorsEditorEngine engine;
    private Operation operation;
    private PriorsEditorGUI gui;
    
    /**
     * Returns an OperationsPanelContextMenu corresponding to the selected element (at index) in a list (fitted with DefaultListModel)
     * @param index
     * @param gui
     * @return
     */
    public static OperationsPanelContextMenu getInstance(JList list, int index, PriorsEditorGUI gui) {
         if (index==-1) return null;
         DefaultListModel model=(DefaultListModel)list.getModel();
         return new OperationsPanelContextMenu((Operation)model.getElementAt(index),gui);
    }
    
        private OperationsPanelContextMenu(Operation operation, PriorsEditorGUI gui) {
            this.engine=gui.getEngine();
            this.operation=operation;
            this.gui=gui;
            ArrayList<Data> datalist=new ArrayList<Data>(3);
            Class[] sourcelists=operation.getDataSourcePreferences();
            for (int i=0;i<sourcelists.length;i++) {
                 datalist.addAll(engine.getAllDataItemsOfType(sourcelists[i]));
            }
            Collections.sort(datalist, new NameComparator());
            // HeaderMenuItem header=new HeaderMenuItem(operation.getName()+" ...", new java.awt.Color(255,255,255), new java.awt.Color(150,150,255));
            // this.add(header);
            DataItemMenuListener menulistener=new DataItemMenuListener();
            for (Data item:datalist) {
                JMenuItem menuitem=new JMenuItem(item.getName());
                menuitem.addActionListener(menulistener);
                this.add(menuitem);
            }
        }
        
        
        /**
         * An inner class that listens to popup-menu events and notifies the gui events
         */
        private class DataItemMenuListener implements ActionListener {
           public void actionPerformed(ActionEvent e) {
                Data dataset=engine.getDataItem(e.getActionCommand());
                OperationTask parameters=new OperationTask(operation.getName());
                parameters.setParameter(OperationTask.OPERATION, operation);
                parameters.setParameter(OperationTask.SOURCE, dataset);
                gui.launchOperationEditor(parameters);
           }            
        }
        

        /**
         * Just an inner class to sort datasets alphabetically in the popup menu
         */
        private class NameComparator implements Comparator<Data> {        
            public int compare(Data o1, Data o2) {
                return o1.getName().compareTo(o2.getName());
            }
            public boolean equals(Data o1, Data o2) {
                return o1.getName().equals(o2.getName());
            }           
        }
        
}
