/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import priorseditor.engine.operations.Operation;
import javax.swing.DefaultListModel;
import priorseditor.engine.PriorsEditorEngine;
import java.util.ArrayList;

/**
 * This class implements a list model that backs up the lists of available
 * datasets (sequences and features) displayed in the left panels of the editor
 * 
 * The listmodel reflects the data that is currently available through the engine
 * and keeps its own ordering for visualization purposes
 * 
 * @author kjetikl
 */
public class OperationsPanelListModel extends DefaultListModel {
    PriorsEditorEngine engine=null;
    
    public OperationsPanelListModel(PriorsEditorEngine engine) {
        this.engine=engine;
        ArrayList<Operation> list=engine.getAllOperations();
        for (Operation item:list) {            
            addElement(item);
        }        
    }
    
    public PriorsEditorEngine getEngine() {
        return engine;
    }  
    
    /**
     * This overridden implementation of addElements will add the element
     * to the correct position in a sorted list rather than adding it at
     * the end of the list
     * 
     * @param o Element to be added
     */
    @Override
    public void addElement(Object o) {
        if (getSize()==0) {super.addElement(o);return;}
        boolean added=false;
        for (int i=0;i<getSize();i++) {
            Object other=getElementAt(i);
            if (o.toString().compareTo(other.toString())<0) {super.add(i, o);added=true;break;}
        }
        if (!added) super.addElement(o);
    }
    
}



