/*
 * OutputPanel.java
 *
 * Created on 7. oktober 2008, 14:44
 */

package priorseditor.gui;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.text.Document;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.print.PrinterException;
import javax.swing.text.html.HTMLEditorKit;
import priorseditor.engine.data.OutputData;

/**
 *
 * @author  kjetikl
 */
public class OutputPanel extends javax.swing.JPanel {
    private JEditorPane outputEditor;
    private OutputData outputdata;
    private Document document;
    
    /** Creates new form OutputPanel */
    public OutputPanel(OutputData outputdata,PriorsEditorGUI gui) {
        this.outputdata=outputdata;
        initComponents();
        this.setLayout(new BorderLayout());   
        this.document=outputdata.getDocument();        
        outputEditor=new JEditorPane();
        if (outputdata.isHTMLformatted()) {
            outputEditor.setEditorKit(new HTMLEditorKit());
            outputEditor.setDocument(((HTMLEditorKit)outputEditor.getEditorKit()).createDefaultDocument());
            try {
                String text=document.getText(0, document.getLength());
                outputEditor.setText(text);              
            } catch (Exception e) {throw new NullPointerException(e.getMessage());}            
        } else {          
           outputEditor.setDocument(document); 
           outputEditor.setCaretPosition(document.getLength());
           outputEditor.setFont(new Font(Font.MONOSPACED,Font.PLAIN,12));
        }
        outputEditor.setEditable(false); // this is the best solution. In this case we don't encounter problems/inconsistencies related to undo/redo
        JScrollPane outputPanelScroll=new JScrollPane(outputEditor);   
        outputPanelScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        this.add(outputPanelScroll,java.awt.BorderLayout.CENTER);        
    }

    /** 
     * Returns the Document used to display the data contained in the associated output object
     * Note that this could be the same as the document in the output data object, but it could also
     * be a different object (for HTML formatted output data)
     */
    public Document getDocument() {
        return document; 
    }
    
    /** Returns the OutputData object displayed in this OutputPanel*/
    public OutputData getOutputData() {
        return outputdata; 
    }
    
    /** Prints the contents of the output object to a selected printer */
    public void print() throws PrinterException {
        outputEditor.print();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setName("Form"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
