/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.CompoundEdit;

/**
 * This class represents objects that listen to undo events and add them to an
 * internal queue. All events that have occurred can then be undone as a single event.
 * The RecordingCompoundEdit has to be registered as an UndoableEditListener somewhere,
 * for instance as a "forward recipient" for events sent to the GUIUndoManager.
 * Also not that the "end()" method must be called on this object after all events
 * have been recorded and before undo() is called, otherwise undo() will throw a 
 * CannotUndoException
 * 
 * @author kjetikl
 */
public class RecordingCompoundEdit extends CompoundEdit implements UndoableEditListener  {
        private String presentationname=null;
        public RecordingCompoundEdit() {
            super();
        }
        public RecordingCompoundEdit(String presentationname) {
            super();
            this.presentationname=presentationname;
        }

        public void undoableEditHappened(UndoableEditEvent e) {
             this.addEdit(e.getEdit());
        }
        @Override
        public String getPresentationName() {
            if (presentationname==null) return super.getPresentationName();
            else return presentationname;
        }
 }