/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import java.awt.Font;
import java.awt.event.ActionEvent;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import java.awt.event.ActionListener;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JSeparator;
import javax.swing.JMenu;
import javax.swing.ActionMap;


/**
 *
 * @author kjetikl
 */
public class SequenceContextMenu extends JPopupMenu  {
    // Please note that all these labels should be distinct (even in submenus!)
    private static String LABEL_ZOOM="Zoom";
    private static String LABEL_ORIENTATION="Orientation";
    private static String LABEL_ORIENTATION_FLIP_POINT="Flip Around Point";
    private static String LABEL_ALIGNMENT="Alignment";
    private static String LABEL_RULER="Ruler";
    private static String LABEL_RULER_TSS="Origo At Gene TSS";
    private static String LABEL_RULER_LEFT_END="Origo At Left End";
    private static String LABEL_RULER_RIGHT_END="Origo At Right End";
    private static String LABEL_RULER_CHROMOSOME="Origo At Chromosome Start";
    private static String LABEL_RULER_FIXED="Fixed Ruler";
    private static String LABEL_RULER_NONE="No Ruler";
    private static String LABEL_REORDER="Reorder Sequences";
    private static String HIDE_SEQUENCE="Hide Sequence";
    private static Font headerfont=new Font(Font.SANS_SERIF,Font.BOLD,12);

    //private static FeatureSequenceData sequenceData;
    private static PriorsEditorGUI gui;
    private static int position=-1;
    private static String sequenceName=null;
    private static SequenceContextMenu thismenu=null;
    private static JMenuItem header=null;
    private static JCheckBoxMenuItem menuitemRulerTSS;
    private static JCheckBoxMenuItem menuitemRulerLeftEnd;
    private static JCheckBoxMenuItem menuitemRulerRightEnd;
    private static JCheckBoxMenuItem menuitemRulerChromosome;
    private static JCheckBoxMenuItem menuitemRulerFixed;
    private static JCheckBoxMenuItem menuitemRulerNone;
    private static JCheckBoxMenuItem menuitemAlignNone;
    private static JCheckBoxMenuItem menuitemAlignLeft;
    private static JCheckBoxMenuItem menuitemAlignRight;
    private static JCheckBoxMenuItem menuitemAlignTSS;
    private static JMenuItem moveUpMenuItem=null;
    private static JMenuItem moveDownMenuItem=null;
    private static JMenuItem setViewportMenuItem=null;
    private static JMenuItem hideSequenceMenuItem=null;
    private static JMenuItem hideOtherSequencesMenuItem=null;
    private static SequenceVisualizer sequenceVisualizer;
    private static ActionMap actionMap;
    private static ActionMap visualizationPanelActionMap;
    
    public static SequenceContextMenu getInstance(SequenceVisualizer sequencevisualizer, int screenPosition, PriorsEditorGUI GUI) {
         position=screenPosition;
         sequenceVisualizer=sequencevisualizer;
         gui=GUI;
         sequenceName=sequenceVisualizer.getSequenceName();
         actionMap=sequenceVisualizer.getActionMap();
         VisualizationPanel parent=sequencevisualizer.getVisualizationPanel();
         if (parent!=null) visualizationPanelActionMap=parent.getActionMap();
         thismenu=new SequenceContextMenu();
         header.setText(sequenceName);
         String currentRuler=gui.getVisualizationSettings().getRuler(null);
              if (currentRuler.equals(VisualizationSettings.RULER_TSS)) menuitemRulerTSS.setSelected(true);
         else if (currentRuler.equals(VisualizationSettings.RULER_LEFT_END)) menuitemRulerLeftEnd.setSelected(true);
         else if (currentRuler.equals(VisualizationSettings.RULER_RIGHT_END)) menuitemRulerRightEnd.setSelected(true);
         else if (currentRuler.equals(VisualizationSettings.RULER_CHROMOSOME)) menuitemRulerChromosome.setSelected(true);
         else if (currentRuler.equals(VisualizationSettings.RULER_FIXED)) menuitemRulerFixed.setSelected(true);
         else if (currentRuler.equals(VisualizationSettings.RULER_NONE)) menuitemRulerNone.setSelected(true);
         String currentAlignment=gui.getVisualizationSettings().getSequenceAlignment(sequenceName);
              if (currentAlignment.equals(VisualizationSettings.ALIGNMENT_NONE)) menuitemAlignNone.setSelected(true);
         else if (currentAlignment.equals(VisualizationSettings.ALIGNMENT_LEFT)) menuitemAlignLeft.setSelected(true);
         else if (currentAlignment.equals(VisualizationSettings.ALIGNMENT_RIGHT)) menuitemAlignRight.setSelected(true);
         else if (currentAlignment.equals(VisualizationSettings.ALIGNMENT_TSS)) menuitemAlignTSS.setSelected(true);           
         return thismenu;
    }
    
    
        private SequenceContextMenu() {
            MenuItemListener menuItemListener=new MenuItemListener();

            JMenuItem menuitem;
                 
            JMenu zoomMenu=new JMenu(LABEL_ZOOM);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ZOOM_IN));
                menuitem.setIcon(null);
                zoomMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ZOOM_OUT));
                menuitem.setIcon(null);
                zoomMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ZOOM_RESET));
                menuitem.setIcon(null);
                zoomMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ZOOM_TO_FIT));
                menuitem.setIcon(null);
                zoomMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ZOOM_TO_CUSTOM_LEVEL));
                menuitem.setIcon(null);
                zoomMenu.add(menuitem);

            JMenu orientationMenu=new JMenu(LABEL_ORIENTATION);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ORIENTATION_DIRECT));
                menuitem.setIcon(null);
                orientationMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ORIENTATION_REVERSE));
                menuitem.setIcon(null);
                orientationMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ORIENTATION_FROM_GENE));
                menuitem.setIcon(null);
                orientationMenu.add(menuitem);
                menuitem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_ORIENTATION_FLIP));
                menuitem.setIcon(null);
                orientationMenu.add(menuitem);
                menuitem=new JMenuItem(LABEL_ORIENTATION_FLIP_POINT);
                menuitem.addActionListener(menuItemListener);
                orientationMenu.add(menuitem);

            ButtonGroup alignmentgroup=new ButtonGroup();
            JMenu alignmentMenu=new JMenu(LABEL_ALIGNMENT);

            menuitemAlignLeft=new JCheckBoxMenuItem(visualizationPanelActionMap.get(SequenceVisualizer.ACTION_ALIGN_LEFT));
                menuitemAlignLeft.setIcon(null);
                alignmentMenu.add(menuitemAlignLeft);
                alignmentgroup.add(menuitemAlignLeft);
            menuitemAlignRight=new JCheckBoxMenuItem(visualizationPanelActionMap.get(SequenceVisualizer.ACTION_ALIGN_RIGHT));
                menuitemAlignRight.setIcon(null);
                alignmentMenu.add(menuitemAlignRight);
                alignmentgroup.add(menuitemAlignRight);
            menuitemAlignTSS=new JCheckBoxMenuItem(SequenceVisualizer.ACTION_ALIGN_TSS_HERE);
                menuitemAlignTSS.addActionListener(menuItemListener);
                alignmentMenu.add(menuitemAlignTSS);
                alignmentgroup.add(menuitemAlignTSS);
            menuitemAlignNone=new JCheckBoxMenuItem(visualizationPanelActionMap.get(SequenceVisualizer.ACTION_ALIGN_NONE));
                menuitemAlignNone.setIcon(null);
                alignmentMenu.add(menuitemAlignNone);
                alignmentgroup.add(menuitemAlignNone);
                
            ButtonGroup rulergroup=new ButtonGroup();
            JMenu rulerMenu=new JMenu(LABEL_RULER);
             menuitemRulerTSS=new JCheckBoxMenuItem(LABEL_RULER_TSS);
                menuitemRulerTSS.addActionListener(menuItemListener);
                rulerMenu.add(menuitemRulerTSS);
                rulergroup.add(menuitemRulerTSS);
             menuitemRulerChromosome=new JCheckBoxMenuItem(LABEL_RULER_CHROMOSOME);
                menuitemRulerChromosome.addActionListener(menuItemListener);
                rulerMenu.add(menuitemRulerChromosome);
                rulergroup.add(menuitemRulerChromosome);
            menuitemRulerLeftEnd=new JCheckBoxMenuItem(LABEL_RULER_LEFT_END);
                menuitemRulerLeftEnd.addActionListener(menuItemListener);
                //rulerMenu.add(menuitemRulerLeftEnd);
                rulergroup.add(menuitemRulerLeftEnd);
             menuitemRulerRightEnd=new JCheckBoxMenuItem(LABEL_RULER_RIGHT_END);
                menuitemRulerRightEnd.addActionListener(menuItemListener);
                //rulerMenu.add(menuitemRulerRightEnd);
                rulergroup.add(menuitemRulerRightEnd);
             menuitemRulerFixed=new JCheckBoxMenuItem(LABEL_RULER_FIXED);
                menuitemRulerFixed.addActionListener(menuItemListener);
                rulerMenu.add(menuitemRulerFixed);
                rulergroup.add(menuitemRulerFixed);
             menuitemRulerNone=new JCheckBoxMenuItem(LABEL_RULER_NONE);
                menuitemRulerNone.addActionListener(menuItemListener);
                rulerMenu.add(menuitemRulerNone);
                rulergroup.add(menuitemRulerNone);

            JMenu rearrangeMenu=new JMenu(LABEL_REORDER);
                moveUpMenuItem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_REORDER_MOVE_UP));
                moveUpMenuItem.setIcon(null);
                rearrangeMenu.add(moveUpMenuItem);
                moveDownMenuItem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_REORDER_MOVE_DOWN));
                moveDownMenuItem.setIcon(null);
                rearrangeMenu.add(moveDownMenuItem);
         
            setViewportMenuItem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_SET_VIEWPORT));
            setViewportMenuItem.setIcon(null);
            hideSequenceMenuItem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_HIDE_SEQUENCE));
            hideSequenceMenuItem.setIcon(null);
            hideOtherSequencesMenuItem=new JMenuItem(actionMap.get(SequenceVisualizer.ACTION_HIDE_OTHER_SEQUENCES));
            hideOtherSequencesMenuItem.setIcon(null);
                
            header=new JMenuItem("");
            header.setEnabled(false);
            header.setFont(headerfont);
            this.add(header);
            this.add(new JSeparator());
            this.add(setViewportMenuItem);
            this.add(zoomMenu);
            this.add(orientationMenu);
            this.add(alignmentMenu);
            this.add(rulerMenu);
            this.add(rearrangeMenu);
            this.add(hideSequenceMenuItem);
            this.add(hideOtherSequencesMenuItem);
        }
        
        
        
        /** Returns true if this popup menu is currently being displayed */
        public static boolean isPopupShowing() {
            if (thismenu!=null && thismenu.isVisible()) return true;
            else return false;
        }

         /**
         * An inner class that listens and responds to popup-menu items that are not wired to Actions
         */       
        private class MenuItemListener implements ActionListener {
           @Override
           public void actionPerformed(ActionEvent e) {
               //gui.debugMessage("Selected "+e.getActionCommand());                   
                       if (e.getActionCommand().equals(LABEL_ORIENTATION_FLIP_POINT)) {
                       gui.getVisualizationSettings().flipSequenceAroundFixedPoint(sequenceName,position);
                } else if (e.getActionCommand().equals(SequenceVisualizer.ACTION_ALIGN_TSS_HERE)) {
                       VisualizationPanel panel=sequenceVisualizer.getVisualizationPanel();
                       if (panel!=null) panel.alignAllSequencesToTSSHere(position);
                } else if (e.getActionCommand().equals(LABEL_RULER_TSS)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_TSS);
                } else if (e.getActionCommand().equals(LABEL_RULER_LEFT_END)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_LEFT_END);
                } else if (e.getActionCommand().equals(LABEL_RULER_RIGHT_END)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_RIGHT_END);
                } else if (e.getActionCommand().equals(LABEL_RULER_CHROMOSOME)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_CHROMOSOME);
                } else if (e.getActionCommand().equals(LABEL_RULER_FIXED)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_FIXED);
                } else if (e.getActionCommand().equals(LABEL_RULER_NONE)) {
                       gui.getVisualizationSettings().setRuler(null,VisualizationSettings.RULER_NONE);
                } 
           }            
        }
        
       
        
}