/*
 * SetRangeDialog.java
 *
 * Created on 28. oktober 2009, 13:32
 */

package priorseditor.gui;

import priorseditor.engine.data.NumericDataset;

/**
 *
 * @author  kjetikl
 */
public class SetRangeDialog extends javax.swing.JDialog {
    private Object dataset; // this is either a single NumericDataset or an array of NumericDatasets
    private PriorsEditorGUI gui;
    
    /** Creates new form SetRangeDialog */
    public SetRangeDialog(PriorsEditorGUI gui, NumericDataset dataset) {
        super(gui.getFrame(), true);
        this.gui=gui;
        initComponents();
        setTitle("Set data range");
        minTextField.setText(""+dataset.getMinAllowedValue());
        maxTextField.setText(""+dataset.getMaxAllowedValue());
        this.dataset=dataset;
        getRootPane().setDefaultButton(okButton);
    }
    
    /** Creates new form SetRangeDialog */
    public SetRangeDialog(PriorsEditorGUI gui, NumericDataset[] datasets) {
        super(gui.getFrame(), true);
        this.gui=gui;
        initComponents();
        setTitle("Set data range");
        float max=-Float.MAX_VALUE;
        float min=Float.MAX_VALUE;
        for (NumericDataset data:datasets) {
            if (data.getMinAllowedValue()<min) min=data.getMinAllowedValue();
            if (data.getMaxAllowedValue()>max) max=data.getMaxAllowedValue();            
        }
        minTextField.setText(""+min);
        maxTextField.setText(""+max);
        this.dataset=datasets;
        getRootPane().setDefaultButton(okButton);
    }
    
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        scaleToFitButton = new javax.swing.JButton();
        okButton = new javax.swing.JButton();
        minLabel = new javax.swing.JLabel();
        maxLabel = new javax.swing.JLabel();
        maxTextField = new javax.swing.JTextField();
        minTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(priorseditor.gui.PriorsEditorApp.class).getContext().getResourceMap(SetRangeDialog.class);
        scaleToFitButton.setText(resourceMap.getString("scaleToFitButton.text")); // NOI18N
        scaleToFitButton.setName("scaleToFitButton"); // NOI18N
        scaleToFitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scaleToFitButtonActionPerformed(evt);
            }
        });

        okButton.setText(resourceMap.getString("okButton.text")); // NOI18N
        okButton.setName("okButton"); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        minLabel.setText(resourceMap.getString("minLabel.text")); // NOI18N
        minLabel.setName("minLabel"); // NOI18N

        maxLabel.setText(resourceMap.getString("maxLabel.text")); // NOI18N
        maxLabel.setName("maxLabel"); // NOI18N

        maxTextField.setText(resourceMap.getString("maxTextField.text")); // NOI18N
        maxTextField.setName("maxTextField"); // NOI18N

        minTextField.setText(resourceMap.getString("minTextField.text")); // NOI18N
        minTextField.setName("minTextField"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(scaleToFitButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(minLabel)
                        .addGap(8, 8, 8)
                        .addComponent(minTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 169, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(maxLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(maxTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 169, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(minLabel)
                    .addComponent(minTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(13, 13, 13)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(maxLabel)
                    .addComponent(maxTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(scaleToFitButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void scaleToFitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scaleToFitButtonActionPerformed
    if (dataset instanceof NumericDataset) {
       float[] minmax=((NumericDataset)dataset).getMinMaxValuesFromData();
       setNewValues((NumericDataset)dataset,minmax[0],minmax[1]);      
    } else if (dataset instanceof NumericDataset[]) {
           for (NumericDataset data:((NumericDataset[])dataset)) {
               float[] minmax=data.getMinMaxValuesFromData();
               setNewValues(data,minmax[0],minmax[1]);  
           }        
    }
    setVisible(false);    
}//GEN-LAST:event_scaleToFitButtonActionPerformed


private void setNewValues(NumericDataset data, float newmin, float newmax) {
       if (newmax>newmin) {
           data.setMinAllowedValue(newmin);
           data.setMaxAllowedValue(newmax);
           data.notifyListenersOfDataUpdate();
           float actualNewMin=data.getMinAllowedValue();
           float actualNewMax=data.getMaxAllowedValue();
           String msg="Visualized range for "+data.getName()+" updated to ["+actualNewMin+","+actualNewMax+"] ";
           if (actualNewMin!=newmin || actualNewMax!=newmax) msg+="(the range was expanded to include the baseline value)";
           gui.logMessage(msg);
       }    
}



private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
   try {//GEN-LAST:event_okButtonActionPerformed
       float newmin=Float.parseFloat(minTextField.getText());
       float newmax=Float.parseFloat(maxTextField.getText());
       if (dataset instanceof NumericDataset) {
           setNewValues((NumericDataset)dataset,newmin,newmax);      
       } else if (dataset instanceof NumericDataset[]) {
           for (NumericDataset data:((NumericDataset[])dataset)) {
               setNewValues(data,newmin,newmax);
           }
       }
   } catch (Exception e) {}
   setVisible(false);
}


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel maxLabel;
    private javax.swing.JTextField maxTextField;
    private javax.swing.JLabel minLabel;
    private javax.swing.JTextField minTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JButton scaleToFitButton;
    // End of variables declaration//GEN-END:variables

}
