/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui;

import priorseditor.engine.data.Data;

/**
 *
 * @author kjetikl
 */
public interface VisualizationSettingsListener {
        public static final int REORDERED=1;
        public static final int UPDATED=2;
        public static final int ADDED=3;
        public static final int REMOVED=4;
        
    
    
        /** 
         * Notifies listeners that an update has been made that could
         * affect the order that datatracks are visualized in within sequences
         */
        public void trackReorderEvent(int type, Data affected);
        
        /** 
         * Notifies listeners that an update has been made that could
         * affect the order that sequences or sequence datasets are visualized in
         * this includes adding or removing datasets or sequences
         */
        public void sequencesReorderEvent(int type, Data affected);
        
        /** 
         * Notifies listeners that the size of the sequence window has been changed.
         * All viewports should be updated accordingly to fit the new window
         */
        public void sequenceWindowSizeChangedEvent(int newsize);
        
        /** 
         * Notifies listeners that the size of the sequence margin has been changed
         */
        public void sequenceMarginSizeChangedEvent(int newsize);
        
        /** 
         * Notifies listeners that the name of a dataitem has changed
         */
        public void dataRenamedEvent(String oldname, String newname);
        

        
        
        
}
