/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.CardLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import priorseditor.engine.data.NumericVariable;
import priorseditor.engine.data.RegionDataset;
import priorseditor.engine.data.NumericDataset;
import priorseditor.engine.data.NumericMapVariable;
import priorseditor.engine.operations.Condition_position;

/**
 *
 * @author kjetikl
 */
public class ConditionPanel_position extends ConditionPanel {
    private JComboBox dataAcombobox=null;
    private JComboBox dataBregioncombobox=null;
    private JComboBox dataBwigglecombobox=null;
    private JComboBox regionComparator=null;
    private JComboBox wiggleComparator=null;
    private JComboBox notBox=null;
    private String[] comparatorStrings=new String[]{"=",">",">=","<","<=","<>"};
    private String[] regionComparatorStrings=new String[]{"inside","bases overlap","bases not overlap","regions overlap","regions not overlap"};
    private OperationDialog dialog;
    private Condition_position condition;
    
    public ConditionPanel_position(Condition_position condition, OperationDialog dialog) {
        super();
        if (condition==null) this.condition=new Condition_position();
        else this.condition=condition;
        this.dialog=dialog;
        init();
    }
    
    /**
     * Initializes the values in the ConditionPanel_position based on the supplied Condition
     */
    private void init() {
        setLayout(new FlowLayout(FlowLayout.LEADING));
        final JPanel cardsPanel=new JPanel(new CardLayout());
        JPanel clausePanel[]=new JPanel[3];
        String dataA_string=condition.getOperandAString();
        String dataB_string=condition.getOperandBString();
        if (dataB_string==null || dataB_string.isEmpty()) dataB_string="1.0";
        String whereComparatorString=condition.getComparator();   
        Boolean whereNot=condition.negateAll();
        if (whereNot==null) whereNot=Boolean.FALSE;
        DefaultComboBoxModel model_dataA=dialog.getDataCandidates(new Class[]{RegionDataset.class,NumericDataset.class});
        DefaultComboBoxModel model_dataBregion=dialog.getDataCandidates(new Class[]{RegionDataset.class});
        DefaultComboBoxModel model_dataBwiggle=dialog.getDataCandidates(new Class[]{NumericVariable.class,NumericMapVariable.class,NumericDataset.class});
        dataAcombobox = new JComboBox(model_dataA);
        dataBregioncombobox = new JComboBox(model_dataBregion);
        dataBwigglecombobox = new JComboBox(model_dataBwiggle);
        dataBwigglecombobox.setEditable(true);
        regionComparator = new JComboBox(regionComparatorStrings);
        wiggleComparator = new JComboBox(comparatorStrings);

        String[] notboxchoices=new String[]{"","not"};
        notBox = new JComboBox(notboxchoices);
        if (whereNot.booleanValue()) notBox.setSelectedIndex(1); else notBox.setSelectedIndex(0); 

        clausePanel[0]=new JPanel(); 
        
        clausePanel[1]=new JPanel(); 
        clausePanel[1].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[1].add(regionComparator);
        clausePanel[1].add(dataBregioncombobox);
             
        clausePanel[2]=new JPanel();
        clausePanel[2].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[2].add(wiggleComparator);
        clausePanel[2].add(dataBwigglecombobox);

        cardsPanel.add(clausePanel[0],"Everywhere");
        cardsPanel.add(clausePanel[1],"Region");
        cardsPanel.add(clausePanel[2],"Wiggle");

        this.add(notBox);       
        this.add(dataAcombobox);       
        this.add(cardsPanel);     
        dataAcombobox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String selectedName=(String)dataAcombobox.getSelectedItem();
                if (selectedName==null || selectedName.isEmpty()) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Everywhere");
                else if (dialog.getClassForDataItem(selectedName)==RegionDataset.class) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Region");
                else if (dialog.getClassForDataItem(selectedName)==NumericDataset.class) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Wiggle");
                else ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Everywhere");
                dialog.pack();
            }
        });
        regionComparator.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String selectedComparator=(String)regionComparator.getSelectedItem();
                if (selectedComparator.equals("inside") || selectedComparator.equals("outside")) dataBregioncombobox.setVisible(false);
                else dataBregioncombobox.setVisible(true);
                dialog.pack();
            }
        });
        String selectedComparator=(String)regionComparator.getSelectedItem();
        if (selectedComparator.equals("inside") || selectedComparator.equals("outside")) dataBregioncombobox.setVisible(false);
        else dataBregioncombobox.setVisible(true);
      
        if (dataA_string!=null && !dataA_string.isEmpty()) dataAcombobox.setSelectedItem(dataA_string);
        else if (dataAcombobox.getModel().getSize()>0) dataAcombobox.setSelectedIndex(0);
        dataBregioncombobox.setSelectedItem(dataB_string);
        dataBwigglecombobox.setSelectedItem(dataB_string);    
        if (whereComparatorString==null || !inStringArray(regionComparatorStrings, whereComparatorString)) regionComparator.setSelectedIndex(0);
        else regionComparator.setSelectedItem(whereComparatorString);
        if (whereComparatorString==null || !inStringArray(comparatorStrings, whereComparatorString)) wiggleComparator.setSelectedIndex(0);
        else wiggleComparator.setSelectedItem(whereComparatorString);   
    }    

    
    /**
     * Updates the parameters in the Condition object based on the selection made by the user in the GUI
     */
    public Condition_position getCondition() {
        String whereOperandA=(String)dataAcombobox.getSelectedItem();
        String whereOperandB=null;
        String whereComparator=null;
        Boolean whereNot=Boolean.FALSE;
        if (whereOperandA==null || whereOperandA.isEmpty()) {
                 whereOperandA=null;
        } else if (dialog.getClassForDataItem(whereOperandA)==RegionDataset.class) {
            whereComparator=(String)regionComparator.getSelectedItem();
            if (whereComparator.equals("inside") || whereComparator.equals("outside")) {
               whereOperandB=null; 
            } else {
               whereOperandB=(String)dataBregioncombobox.getSelectedItem(); 
            }
        } else if (dialog.getClassForDataItem(whereOperandA)==NumericDataset.class) {
            whereComparator=(String)wiggleComparator.getSelectedItem();
            whereOperandB=(String)dataBwigglecombobox.getSelectedItem(); 
            
        }
        if (notBox.getSelectedItem().equals("not")) whereNot=Boolean.TRUE; else whereNot=Boolean.FALSE; 
        condition.setComparator(whereComparator);
        condition.setOperandAString(whereOperandA);
        condition.setOperandBString(whereOperandB);       
        condition.setNegateAll(whereNot);  
        if (whereOperandA==null) return null;
        else return condition;
    }  
    
    
    private boolean inStringArray(String[] list,String element) {
        for (int i=0;i<list.length;i++) {
            if (list[i].equals(element)) return true;
        }
        return false;
    }

}
