/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.CardLayout;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import priorseditor.engine.data.MotifCollection;
import priorseditor.engine.data.NumericMapVariable;
import priorseditor.engine.data.NumericVariable;
import priorseditor.engine.data.RegionDataset;
import priorseditor.engine.data.StringCollection;
import priorseditor.engine.data.NumericDataset;
import priorseditor.engine.operations.Condition_region;


/**
 *
 * @author kjetikl
 */
public class ConditionPanel_region extends ConditionPanel {
    private JTextField expressionTextfield=null; // compare type against literal expression
    private JComboBox typeCollectionCombobox=null; // compare type against selected collection
    private JComboBox numericScoreCombobox=null; // numeric value used for score&length comparison 
    private JComboBox numericCombobox=null; // numeric value used for avg|min|max|median comparison with wiggle   
    private JComboBox wiggleCombobox=null; // wiggle dataset for avg|min|max|median comparison
    private JComboBox regionCombobox=null; // region dataset for overlaps comparison
    private JComboBox numericComparatorCombobox=null; // =|>|>=|<|<=|<> for score&length comparison
    private JComboBox numericWiggleComparatorCombobox=null; // =|>|>=|<|<=|<> for avg|min|max|median wiggle comparison
    private JComboBox stringComparatorCombobox=null; // equals|matches|in
    private JComboBox comparePropertyCombobox=null; // type|score|length|overlaps|average|min|max|median
    private JComboBox notComboBox=null; // negate all?
    private String[] numericComparatorStrings=new String[]{"=",">",">=","<","<=","<>"};
    private String[] stringComparatorStrings=new String[]{"equals","matches","in set"};
    private String[] comparePropertyStrings=new String[]{"type","score","length","overlaps","distance to","min","max","average","median","sum"};
    private OperationDialog dialog;
    private Condition_region condition;

    
    private DefaultComboBoxModel model_wiggle;
    private DefaultComboBoxModel model_region;   
    
    
    public ConditionPanel_region(Condition_region condition, OperationDialog dialog) {
        super();
        if (condition==null) this.condition=new Condition_region();
        else this.condition=condition;
        this.dialog=dialog;
        init();
    }
    
    /**
     * Initializes the values in the ConditionPanel_wiggle based on the supplied Condition
     */
    private void init() {
        setLayout(new FlowLayout(FlowLayout.LEADING));
        final JPanel cardsPanel=new JPanel(new CardLayout());
        JPanel clausePanel[]=new JPanel[5];
        String compareProperty=condition.getCompareProperty();
        if (compareProperty==null || compareProperty.isEmpty()) compareProperty="type";
        String comparator=condition.getComparator();
        String operandAString=condition.getOperandAString();
        String operandBString=condition.getOperandBString();
        if (compareProperty.equals("maximum")) compareProperty="max";
        else if (compareProperty.equals("minimum")) compareProperty="min";
        else if (compareProperty.equals("avg")) compareProperty="average";
        Boolean whereNot=condition.negateAll();
        if (whereNot==null) whereNot=Boolean.FALSE;

        model_wiggle=dialog.getDataCandidates(new Class[]{NumericDataset.class});
        model_region=dialog.getDataCandidates(new Class[]{RegionDataset.class});
        DefaultComboBoxModel model_collection=dialog.getDataCandidates(new Class[]{MotifCollection.class,StringCollection.class});
        wiggleCombobox = new JComboBox();
        if (compareProperty.equals("distance to")) wiggleCombobox.setModel(model_region);
        else wiggleCombobox.setModel(model_wiggle);
        regionCombobox = new JComboBox(model_region);
        typeCollectionCombobox = new JComboBox(model_collection);
        numericCombobox = getNumericCombobox();
        numericScoreCombobox = getNumericCombobox();

        stringComparatorCombobox = new JComboBox(stringComparatorStrings);
        numericComparatorCombobox = new JComboBox(numericComparatorStrings);
        numericWiggleComparatorCombobox = new JComboBox(numericComparatorStrings);
        comparePropertyCombobox = new JComboBox(comparePropertyStrings);
        expressionTextfield=new JTextField(10);
        
        String[] notboxchoices=new String[]{"","not"};
        notComboBox = new JComboBox(notboxchoices);
        if (whereNot.booleanValue()) notComboBox.setSelectedIndex(1); else notComboBox.setSelectedIndex(0); 

        this.add(notComboBox);
        this.add(new JLabel(" region "));
        this.add(comparePropertyCombobox);

        clausePanel[0]=new JPanel(); // "type panel"
        clausePanel[0].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[0].add(stringComparatorCombobox);
        clausePanel[0].add(expressionTextfield);
        clausePanel[0].add(typeCollectionCombobox);
    
        clausePanel[1]=new JPanel(); // "score/length panel"
        clausePanel[1].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[1].add(numericComparatorCombobox);
        clausePanel[1].add(numericScoreCombobox);
             
        clausePanel[2]=new JPanel(); // "overlaps panel"
        clausePanel[2].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[2].setAlignmentY(JComponent.CENTER_ALIGNMENT);
        clausePanel[2].add(regionCombobox);
            
        clausePanel[3]=new JPanel(); // "Wiggle panel"
        clausePanel[3].setLayout(new FlowLayout(FlowLayout.LEADING));
        clausePanel[3].add(wiggleCombobox);
        clausePanel[3].add(numericWiggleComparatorCombobox);
        clausePanel[3].add(numericCombobox);
        
        clausePanel[4]=new JPanel();

        cardsPanel.add(clausePanel[0],"Type");
        cardsPanel.add(clausePanel[1],"ScoreLength");
        cardsPanel.add(clausePanel[2],"Overlaps");
        cardsPanel.add(clausePanel[3],"Wiggle");
        cardsPanel.add(clausePanel[4],"NoCondition");
   
        this.add(cardsPanel);  

        comparePropertyCombobox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String selectedProperty=(String)comparePropertyCombobox.getSelectedItem();
                     if (selectedProperty.equals("")) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "NoCondition");
                else if (selectedProperty.equals("type")) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Type");
                else if (selectedProperty.equals("score") || selectedProperty.equals("length")) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "ScoreLength");
                else if (selectedProperty.equals("overlaps")) ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Overlaps");
                else if (selectedProperty.equals("distance to")) {
                    wiggleCombobox.setModel(model_region);
                    ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Wiggle");
                }
                else {
                    wiggleCombobox.setModel(model_wiggle);
                    ((CardLayout)cardsPanel.getLayout()).show(cardsPanel, "Wiggle");
                }
                dialog.pack();
            }
        });
        stringComparatorCombobox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String selectedComparator=(String)stringComparatorCombobox.getSelectedItem();
                if (selectedComparator!=null && selectedComparator.equals("in set")) {expressionTextfield.setVisible(false);typeCollectionCombobox.setVisible(true);}
                else {typeCollectionCombobox.setVisible(false);expressionTextfield.setVisible(true);}
                dialog.pack();
            }
        });
        numericComparatorCombobox.setSelectedIndex(0);
        numericWiggleComparatorCombobox.setSelectedIndex(0);
        stringComparatorCombobox.setSelectedItem(comparator);
        if (stringComparatorCombobox.getSelectedIndex()<0) stringComparatorCombobox.setSelectedIndex(0);
        if (comparator==null) {}
        else if (isNumericalComparison(comparator)) {
            if (operandBString!=null && !operandBString.isEmpty()) numericCombobox.setSelectedItem(operandBString); 
            if (operandBString!=null && !operandBString.isEmpty()) numericScoreCombobox.setSelectedItem(operandBString);
            if (operandAString!=null && !operandAString.isEmpty()) wiggleCombobox.setSelectedItem(operandAString); 
            numericComparatorCombobox.setSelectedItem(comparator);
            numericWiggleComparatorCombobox.setSelectedItem(comparator);
        } else if (comparator.equals("in set")) {
            if (operandBString!=null && !operandBString.isEmpty())  typeCollectionCombobox.setSelectedItem(operandBString);
        } else if (comparator.equals("equals") || comparator.equals("matches")) {
            expressionTextfield.setText(operandBString.replaceAll("\"", ""));
        } else if (compareProperty.equals("overlaps")) {
            if (operandBString!=null && !operandBString.isEmpty()) regionCombobox.setSelectedItem(operandBString); 
        } 
        if (compareProperty==null || compareProperty.isEmpty()) comparePropertyCombobox.setSelectedIndex(0);
        else comparePropertyCombobox.setSelectedItem(compareProperty);
        if (numericCombobox.getSelectedItem()==null || ((String)numericCombobox.getSelectedItem()).isEmpty()) numericCombobox.setSelectedItem("1.0");
        if (numericScoreCombobox.getSelectedItem()==null || ((String)numericScoreCombobox.getSelectedItem()).isEmpty()) numericScoreCombobox.setSelectedItem("1.0");
    }    

    
    /**
     * Updates the parameters in the Condition object based on the selection made by the user in the GUI
     */
    @Override
    public Condition_region getCondition() {
        String operandAString=null;
        String operandBString=null;
        String comparator=null;
        String compareProperty=(String)comparePropertyCombobox.getSelectedItem();
        Boolean whereNot=Boolean.FALSE;
        boolean OK=true;
        if (notComboBox.getSelectedItem().equals("not")) whereNot=Boolean.TRUE; else whereNot=Boolean.FALSE; 
        if (compareProperty==null || compareProperty.isEmpty()) {OK=false;}
        else if (compareProperty.equals("type")) {
            comparator=(String)stringComparatorCombobox.getSelectedItem();
            if (comparator.equals("in set")) {
                operandBString=(String)typeCollectionCombobox.getSelectedItem();
                if (operandBString==null || operandBString.isEmpty()) OK=false;
            }                
            else {
                operandBString=expressionTextfield.getText().trim();
                operandBString.replaceAll("\"", ""); // remove quotes that the user has entered
                if (operandBString.isEmpty()) OK=false;
                operandBString="\""+operandBString+"\""; // add quotes
            }            
        } else if (compareProperty.equals("score") || compareProperty.equals("length")) {
            comparator=(String)numericComparatorCombobox.getSelectedItem();
            operandBString=((String)numericScoreCombobox.getSelectedItem()).trim();
            if (operandBString==null || operandBString.isEmpty()) OK=false;
        } else if (compareProperty.equals("overlaps")) {
            operandBString=(String)regionCombobox.getSelectedItem();
            if (operandBString==null || operandBString.isEmpty()) OK=false;
        } else {
            comparator=(String)numericWiggleComparatorCombobox.getSelectedItem();
            operandAString=(String)wiggleCombobox.getSelectedItem();
            operandBString=(String)numericCombobox.getSelectedItem();            
            if (operandBString==null || operandBString.isEmpty()) OK=false;
            if (operandAString==null || operandAString.isEmpty()) OK=false;
        }
        
        condition.setCompareProperty(compareProperty);
        condition.setComparator(comparator);
        condition.setOperandAString(operandAString);
        condition.setOperandBString(operandBString);       
        condition.setNegateAll(whereNot);  
        if (!OK) return null;
        else return condition;
    }  

    
    private boolean inStringArray(String[] list,String element) {
        for (int i=0;i<list.length;i++) {
            if (list[i].equals(element)) return true;
        }
        return false;
    }

    private JComboBox getNumericCombobox() {
        DefaultComboBoxModel model=dialog.getDataCandidates(new Class[]{NumericVariable.class,NumericMapVariable.class},false);
        JComboBox combobox = new JComboBox(model);
        combobox.setEditable(true);  
        return combobox;
    }
    
    private boolean isNumericalComparison(String cmp) {
        return inStringArray(numericComparatorStrings, cmp);
    }
    
    
}
