/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.FlowLayout;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import priorseditor.engine.data.*;
import priorseditor.engine.operations.Operation_mask;

/**
 *
 * @author kjetikl
 */
public class OperationDialog_mask extends FeatureTransformOperationDialog {
    private JPanel maskpanel;
    private JComboBox backgroundCombobox;
    private JTextField maskLetterTextField;
    private JRadioButton useLetter; 
    private JRadioButton useLowerCase; 
    private JRadioButton useUpperCase; 
    private JRadioButton useBackgroundModel; 

    
    public OperationDialog_mask(JFrame parent) {
        super(parent);    
    }
    
    public OperationDialog_mask() {
        super();    
    }
    
    @Override
    public void initComponents() {
        super.initComponents();
        maskpanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        maskpanel.setBorder(commonBorder);
        JLabel masklabel=new JLabel("Mask with   ");
        maskpanel.add(masklabel);
        JPanel maskChoicePanel = new JPanel();
        maskChoicePanel.setLayout(new BoxLayout(maskChoicePanel,BoxLayout.Y_AXIS));
        ButtonGroup buttonGroup=new ButtonGroup();
        useLowerCase=new JRadioButton("lowercase letters");
        useUpperCase=new JRadioButton("uppercase letters");
        useLetter=new JRadioButton("specific letter    ");
        useBackgroundModel=new JRadioButton("random bases  ");
        buttonGroup.add(useLowerCase);
        buttonGroup.add(useUpperCase);
        buttonGroup.add(useLetter);
        buttonGroup.add(useBackgroundModel);
        JPanel lowercasepanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        JPanel uppercasepanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        lowercasepanel.add(useLowerCase);
        uppercasepanel.add(useUpperCase);
        JPanel letterpanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        maskLetterTextField = new JTextField(1);
        maskLetterTextField.setText("X");
        letterpanel.add(useLetter);
        letterpanel.add(maskLetterTextField);               
        DefaultComboBoxModel backgroundComboBoxModel=getDataCandidates(new Class[]{BackgroundModel.class});
        backgroundCombobox = new JComboBox(backgroundComboBoxModel);
        backgroundCombobox.setEditable(true);
        JPanel backgroundpanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        backgroundpanel.add(useBackgroundModel);
        backgroundpanel.add(backgroundCombobox);
        maskChoicePanel.add(lowercasepanel);
        maskChoicePanel.add(uppercasepanel);
        maskChoicePanel.add(letterpanel);
        maskChoicePanel.add(backgroundpanel);     
        maskpanel.add(maskChoicePanel);
        String maskString=(String)parameters.getParameter(Operation_mask.MASK_STRING);
        if (maskString==null || maskString.isEmpty()) {
           useLetter.setSelected(true);  
        } else if (maskString.equalsIgnoreCase("uppercase")) {
           useUpperCase.setSelected(true); 
        } else if (maskString.equalsIgnoreCase("lowercase")) {
           useLowerCase.setSelected(true); 
        } else if (maskString.startsWith("'")) {
           useLetter.setSelected(true);
           if (maskString.length()>1) maskLetterTextField.setText(maskString.substring(1,2));
        } else {
           useBackgroundModel.setSelected(true);
           backgroundCombobox.setSelectedItem(maskString);           
        }
     
        JPanel sourceTargetPanel=getSourceTargetPanel();
        sourceTargetPanel.setBorder(commonBorder);
        JPanel whereClausePanel=getWhereClausePanel(FeatureTransformOperationDialog.CONDITION_NUMERIC);
        whereClausePanel.setBorder(commonBorder);
        JPanel subsetPanel=getSequenceSubsetPanel();
        subsetPanel.setBorder(commonBorder);
        add(sourceTargetPanel);
        add(maskpanel);
        add(whereClausePanel);
        add(subsetPanel);
        add(getOKCancelButtonsPanel());
        pack();        
    }

    @Override
    protected void setParameters() {
        super.setParameters(); // sets the common feature-transform parameters like 'source','target','where' and 'collection'
        String maskString="";
             if (useLetter.isSelected()) maskString="'"+maskLetterTextField.getText()+"'";
        else if (useLowerCase.isSelected()) maskString="lowercase";
        else if (useUpperCase.isSelected()) maskString="uppercase";
        else if (useBackgroundModel.isSelected()) maskString=(String)backgroundCombobox.getSelectedItem();
        parameters.setParameter(Operation_mask.MASK_STRING, maskString);
    }
}
