/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.FlowLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import priorseditor.engine.OperationTask;
import priorseditor.engine.operations.Operation_prompt;
import priorseditor.engine.operations.Operation;


/**
 *
 * @author kjetikl
 */
public class OperationDialog_prompt extends OperationDialog {
    private JPanel sourcePanel;
    private JPanel messagePanel;
    private JTextField messageTextfield;
    private JComboBox sourceCombobox;
    
    
    public OperationDialog_prompt(JFrame parent) {
        super(parent);    
    }
    
    public OperationDialog_prompt() {
        super();    
    }
    
    @Override
    public void initComponents() {
        super.initComponents();
        sourcePanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        sourcePanel.setBorder(commonBorder);
        sourcePanel.add(new JLabel("Target "));

        Operation promptOperation=engine.getOperation("prompt");
        DefaultComboBoxModel sourceComboModel=getDataCandidates(promptOperation.getDataSourcePreferences());

        sourceCombobox = new JComboBox(sourceComboModel);
        sourceCombobox.setEditable(true);
        String currentSourceData=(String)parameters.getParameter(OperationTask.SOURCE_NAME);
        if (currentSourceData!=null && !currentSourceData.isEmpty()) sourceCombobox.setSelectedItem(currentSourceData);
        else sourceCombobox.setSelectedIndex(0);
        sourcePanel.add(sourceCombobox);                   
        messagePanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        messagePanel.setBorder(commonBorder);
        messagePanel.add(new JLabel("Message "));
        messageTextfield=new JTextField();
        messagePanel.add(messageTextfield);
        messageTextfield.setColumns(26);
        String currentMessage=(String)parameters.getParameter(Operation_prompt.PROMPT_MESSAGE);
        if (currentMessage!=null) messageTextfield.setText(currentMessage);
        add(sourcePanel);
        add(messagePanel);
        add(getOKCancelButtonsPanel());
        pack();        
    }

    @Override
    protected void setParameters() {
        String sourceName=(String)sourceCombobox.getSelectedItem();
        parameters.setParameter(OperationTask.SOURCE_NAME,sourceName);
        parameters.setParameter(OperationTask.TARGET_NAME,sourceName);
        String message=messageTextfield.getText().trim();
        if (!message.isEmpty()) parameters.setParameter(Operation_prompt.PROMPT_MESSAGE, message);
        else parameters.setParameter(Operation_prompt.PROMPT_MESSAGE, null);
    }
}
