/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import priorseditor.engine.data.*;
import priorseditor.engine.operations.Operation_rescore;

/**
 *
 * @author kjetikl
 */
public class OperationDialog_rescore extends FeatureTransformOperationDialog {
    private JPanel rescorebypanel;
    private JComboBox rescorebyCombobox;
    private JComboBox rescoreOperatorCombobox;
    private JComboBox rescoreTypeCombobox;
    
    
    public OperationDialog_rescore(JFrame parent) {
        super(parent);    
    }
    
    public OperationDialog_rescore() {
        super();    
    }
    
    @Override
    public void initComponents() {
        super.initComponents();
        rescorebypanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        rescorebypanel.setBorder(commonBorder);
        rescorebypanel.add(new JLabel("Rescore   "));
        rescoreTypeCombobox = new JComboBox(new String[]{Operation_rescore.WEIGHT_BY,Operation_rescore.SET_TO});
        String rescoreType=(String)parameters.getParameter(Operation_rescore.RESCORE_TYPE);
        if (rescoreType==null || rescoreType.isEmpty()) rescoreType=Operation_rescore.WEIGHT_BY;
        rescoreTypeCombobox.setSelectedItem(rescoreType);
        rescorebypanel.add(rescoreTypeCombobox);
        String rescoreOperator=(String)parameters.getParameter(Operation_rescore.RESCORE_OPERATOR);
        rescoreOperatorCombobox = new JComboBox(new String[]{"min","max","average","median","sum"});
        if (rescoreOperator!=null && !rescoreOperator.isEmpty()) rescoreOperatorCombobox.setSelectedItem(rescoreOperator);
        else rescoreOperatorCombobox.setSelectedIndex(0);
        rescorebypanel.add(rescoreOperatorCombobox);
        String rescoreDataString=(String)parameters.getParameter(Operation_rescore.RESCORE_DATA_NAME);
        if (rescoreDataString==null || rescoreDataString.isEmpty()) rescoreDataString="1.0";
        DefaultComboBoxModel wbmodel=getDataCandidates(new Class[]{NumericDataset.class,NumericVariable.class});
        rescorebyCombobox = new JComboBox(wbmodel);
        rescorebyCombobox.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String rescoreDataString=(String)rescorebyCombobox.getSelectedItem();
                Class dataclass=getClassForDataItem(rescoreDataString);
                if (dataclass==NumericDataset.class) {
                    // if (!((String)rescoreOperatorCombobox.getSelectedItem()).equals("value") ) rescoreOperatorCombobox.setSelectedItem("min");
                    rescoreOperatorCombobox.setVisible(true);
                } else {
                    //rescoreOperatorCombobox.setSelectedItem("value");
                    rescoreOperatorCombobox.setVisible(false);
                }
            }
        });
        rescorebyCombobox.setEditable(true);
        rescorebyCombobox.setSelectedItem(rescoreDataString);
        rescorebypanel.add(rescorebyCombobox);    
        JPanel sourceTargetPanel=getSourceTargetPanel();
        sourceTargetPanel.setBorder(commonBorder);
        JPanel whereClausePanel=getWhereClausePanel(FeatureTransformOperationDialog.CONDITION_REGION);
        whereClausePanel.setBorder(commonBorder);
        JPanel subsetPanel=getSequenceSubsetPanel();
        subsetPanel.setBorder(commonBorder);
        add(sourceTargetPanel);
        add(rescorebypanel);
        add(whereClausePanel);
        add(subsetPanel);
        add(getOKCancelButtonsPanel());
        pack();        
    }

    @Override
    protected void setParameters() {
        super.setParameters(); // sets the common feature-transform parameters like 'source','target','where' and 'collection'
        String rescoreDataString=(String)rescorebyCombobox.getSelectedItem();
        parameters.setParameter(Operation_rescore.RESCORE_DATA_NAME, rescoreDataString);
        String rescoreOperator=(String)rescoreOperatorCombobox.getSelectedItem();
        Class dataclass=getClassForDataItem(rescoreDataString);
        if (dataclass!=NumericDataset.class) {
            rescoreOperator="value";
        }        
        parameters.setParameter(Operation_rescore.RESCORE_OPERATOR,rescoreOperator);
        parameters.setParameter(Operation_rescore.RESCORE_TYPE, (String)rescoreTypeCombobox.getSelectedItem());
    }
}
