/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.FlowLayout;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import priorseditor.engine.data.*;
import priorseditor.engine.operations.Operation_score;

/**
 *
 * @author kjetikl
 */
public class OperationDialog_score extends FeatureTransformOperationDialog {
    private JPanel motifpanel;
    private JComboBox motifCombobox;
    
    
    public OperationDialog_score(JFrame parent) {
        super(parent);    
    }
    
    public OperationDialog_score() {
        super();    
    }
    
    @Override
    public void initComponents() {
        super.initComponents();
        ActionListener[] listeners=targetDataTextfield.getActionListeners();
        for (ActionListener listener:listeners) targetDataTextfield.removeActionListener(listener);
        targetDataTextfield.setText("motifscore");
        motifpanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        motifpanel.setBorder(commonBorder);
        motifpanel.add(new JLabel("Motif  "));
        String motifName=(String)parameters.getParameter(Operation_score.MOTIFNAME);
        // what if there are no motifs
        DefaultComboBoxModel wbmodel=getDataCandidates(new Class[]{Motif.class,MotifCollection.class});
        motifCombobox = new JComboBox(wbmodel);
        motifCombobox.setEditable(false);
        if (wbmodel.getSize()==0) motifCombobox.setSelectedIndex(-1);
        else if (motifName==null) motifCombobox.setSelectedIndex(0);
        else motifCombobox.setSelectedItem(motifName);
        motifpanel.add(motifCombobox);                   
        JPanel sourceTargetPanel=getSourceTargetPanel();
        sourceTargetPanel.setBorder(commonBorder);
        JPanel whereClausePanel=getWhereClausePanel(FeatureTransformOperationDialog.CONDITION_NUMERIC);
        whereClausePanel.setBorder(commonBorder);
        JPanel subsetPanel=getSequenceSubsetPanel();
        subsetPanel.setBorder(commonBorder);
        add(sourceTargetPanel);
        add(motifpanel);
        add(whereClausePanel);
        add(subsetPanel);
        add(getOKCancelButtonsPanel());
        pack();        
    }

    @Override
    protected void setParameters() {
        super.setParameters(); // sets the common feature-transform parameters like 'source','target','where' and 'collection'
        parameters.setParameter(Operation_score.MOTIFNAME, (String)motifCombobox.getSelectedItem());
    }
}
