/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.operationdialog;

import java.awt.FlowLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import priorseditor.engine.data.*;
import priorseditor.engine.operations.Operation_smooth;

/**
 *
 * @author kjetikl
 */
public class OperationDialog_smooth extends FeatureTransformOperationDialog {
    private JPanel windowpanel;
    private JComboBox windowTypeCombobox;
    private JComboBox windowSizeCombobox;
    private JComboBox windowAnchorCombobox;

    
    public OperationDialog_smooth(JFrame parent) {
        super(parent);    
    }
    
    public OperationDialog_smooth() {
        super();    
    }
    
    @Override
    public void initComponents() {
        super.initComponents();
        windowpanel=new JPanel(new FlowLayout(FlowLayout.LEADING));
        windowpanel.setBorder(commonBorder);
        windowpanel.add(new JLabel("Smooth with window   "));
        windowTypeCombobox = new JComboBox(Operation_smooth.getWindowTypes());
        String windowTypeString=(String)parameters.getParameter(Operation_smooth.WINDOW_TYPE);
        if (windowTypeString==null) windowTypeString=(String)windowTypeCombobox.getModel().getElementAt(0);
        windowTypeCombobox.setSelectedItem(windowTypeString);
        windowpanel.add(windowTypeCombobox);                   
        windowpanel.add(new JLabel("    size  "));
        DefaultComboBoxModel wbmodel=getDataCandidates(new Class[]{NumericVariable.class,NumericMapVariable.class});
        windowSizeCombobox = new JComboBox(wbmodel);
        windowSizeCombobox.setEditable(true);
        windowpanel.add(windowSizeCombobox);                   
        String windowSizeString=(String)parameters.getParameter(Operation_smooth.WINDOW_SIZE);
        if (windowSizeString==null) windowSizeString="5";
        windowSizeCombobox.setSelectedItem(windowSizeString);
        windowAnchorCombobox=new JComboBox(new String[]{Operation_smooth.CENTER,Operation_smooth.UPSTREAM,Operation_smooth.DOWNSTREAM,});
        String windowAnchor=(String)parameters.getParameter(Operation_smooth.ANCHOR);
        if (windowAnchor==null || windowAnchor.isEmpty()) windowAnchor=(String)Operation_smooth.CENTER;
        windowAnchorCombobox.setSelectedItem(windowAnchor);
        windowpanel.add(new JLabel("    anchor  "));
        windowpanel.add(windowAnchorCombobox);
        JPanel sourceTargetPanel=getSourceTargetPanel();
        sourceTargetPanel.setBorder(commonBorder);
        JPanel whereClausePanel=getWhereClausePanel(FeatureTransformOperationDialog.CONDITION_NUMERIC);
        whereClausePanel.setBorder(commonBorder);
        JPanel subsetPanel=getSequenceSubsetPanel();
        subsetPanel.setBorder(commonBorder);
        add(sourceTargetPanel);
        add(windowpanel);
        add(whereClausePanel);
        add(subsetPanel);
        add(getOKCancelButtonsPanel());
        pack();        
    }

    @Override
    protected void setParameters() {
        super.setParameters(); // sets the common feature-transform parameters like 'source','target','where' and 'collection'
        parameters.setParameter(Operation_smooth.WINDOW_TYPE, (String)windowTypeCombobox.getSelectedItem());
        parameters.setParameter(Operation_smooth.WINDOW_SIZE, (String)windowSizeCombobox.getSelectedItem());
        parameters.setParameter(Operation_smooth.ANCHOR, (String)windowAnchorCombobox.getSelectedItem());
    }
}
