/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.prompt;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import priorseditor.engine.PriorsEditorEngine;
import priorseditor.engine.data.DNASequenceDataset;
import priorseditor.engine.data.Data;
import priorseditor.engine.data.BackgroundModel;
import priorseditor.engine.datatracks.DataTrack;
import priorseditor.engine.operations.Operation_new;
import priorseditor.gui.PriorsEditorGUI;
import priorseditor.gui.operationdialog.OperationDialog_new;
/**
 *
 * @author kjetikl
 */
public class Prompt_DNASequenceDataset extends Prompt {
    
    private JTextField defaultbaseTextfield;
    private JComboBox markovModelCombobox;
    private JPanel mainpanel;
    private JLabel messageLabel;
    private String parameters = "";
    private JRadioButton useDefaultBase;
    private JRadioButton useMarkovModel;
    private JRadioButton useDataTrack;
    private OperationDialog_new dialog;
    private JComboBox datatrackCombobox;
    
    
    public Prompt_DNASequenceDataset(PriorsEditorGUI gui, String prompt, String dataname, String parameterString, OperationDialog_new dialog) {
        super(gui,prompt);
        this.dialog=dialog;
        //else data=new NumericVariable("X", 0);
        setDataItemName(dataname);
        setTitle("DNA Sequence Dataset settings");
        mainpanel=new JPanel();
        mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
        //mainpanel.add(valueTextField);
        messageLabel=new JLabel("  ");
        messageLabel.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
        messageLabel.setForeground(java.awt.Color.RED);
        useDefaultBase=new JRadioButton("Initialize with default base");
        useMarkovModel=new JRadioButton("Construct from Background Model");
        useDataTrack=new JRadioButton("Construct from Datatrack");
        ButtonGroup group=new ButtonGroup();
        group.add(useDataTrack);
        group.add(useDefaultBase);
        group.add(useMarkovModel);
        DefaultComboBoxModel comboboxmodel=dialog.getDataCandidates(BackgroundModel.class);
        markovModelCombobox=new JComboBox(comboboxmodel);
        defaultbaseTextfield=new JTextField(3);
        DataTrack[] trackslist=engine.getDataLoader().getAvailableDatatracks(DNASequenceDataset.class);
        String[] tracksnames=new String[trackslist.length];
        for (int i=0;i<trackslist.length;i++) tracksnames[i]=trackslist[i].getName();
        datatrackCombobox=new JComboBox(tracksnames);
        JPanel internPanel=new JPanel();
        internPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        JPanel gridPanel=new JPanel(new GridLayout(3, 2, 10, 10));
        gridPanel.add(useDataTrack);
        gridPanel.add(datatrackCombobox);       
        gridPanel.add(useMarkovModel);
        gridPanel.add(markovModelCombobox);       
        gridPanel.add(useDefaultBase);
        gridPanel.add(defaultbaseTextfield);
        internPanel.add(gridPanel);        
        internPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        mainpanel.add(internPanel);
        mainpanel.add(messageLabel);
        Dimension size=new Dimension(250,60);
        mainpanel.setMinimumSize(size);
        //mainpanel.setPreferredSize(size);
        setMainPanel(mainpanel);        
        defaultbaseTextfield.setText("N");
        if (parameterString==null || parameterString.isEmpty()) {
            useDataTrack.setSelected(true);
        } else if (parameterString.startsWith(Operation_new.DATA_TRACK_PREFIX)) {
            useDataTrack.setSelected(true);
            if (parameterString.length()>Operation_new.DATA_TRACK_PREFIX.length()) {
                String trackname=parameterString.substring(Operation_new.DATA_TRACK_PREFIX.length());
                datatrackCombobox.setSelectedItem(trackname);
            }
        } else {
              Class parclass=dialog.getClassForDataItem(parameterString);
              if (parclass!=null && parclass==BackgroundModel.class) {
                  markovModelCombobox.setSelectedItem(parameterString);
                  useMarkovModel.setSelected(true);
                  defaultbaseTextfield.setText("N");
              } else {
                  if (parameterString.startsWith("'")) parameterString=parameterString.replaceAll("'", "");
                  if (parameterString.isEmpty()) parameterString="N";
                  defaultbaseTextfield.setText(parameterString.substring(0,1));
                  useDefaultBase.setSelected(true);
              }
        }
        pack();
    }
    
    
    @Override
    public boolean onOKPressed() {
        if (useDataTrack.isSelected()) {            
            parameters=Operation_new.DATA_TRACK_PREFIX+(String)datatrackCombobox.getSelectedItem();
        } else if (useDefaultBase.isSelected()) {
            String val=defaultbaseTextfield.getText().trim();
            if (val.isEmpty()) val="N";
            parameters="'"+val.substring(0,1)+"'";
        } else if (useMarkovModel.isSelected()) {
            parameters=(String)markovModelCombobox.getSelectedItem();
        } else{
            parameters="";
        }
        return true;
    }
    
    public Data getData() {
       return null; 
    }
    
    @Override
    public String getValueAsParameterString() {
        return parameters;
    }
    
}