/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.prompt;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import priorseditor.engine.PriorsEditorEngine;
import priorseditor.engine.data.Data;
import priorseditor.engine.data.NumericDataset;
import priorseditor.engine.datatracks.DataTrack;
import priorseditor.engine.operations.Operation_new;
import priorseditor.gui.PriorsEditorGUI;

/**
 *
 * @author kjetikl
 */
public class Prompt_NumericDataset extends Prompt {
    
    private JTextField defaultvalueTextField;
    private JTextField minTextField;
    private JTextField maxTextField;
    private JTextField baselineTextField;
    private JPanel mainpanel;
    private JLabel messageLabel;
    private String parameters = "";
    private JRadioButton useDataTrackRadioButton;
    private JRadioButton useValuesRadioButton;
    private JComboBox datatracksCombobox;
    
    
    
    public Prompt_NumericDataset(PriorsEditorGUI gui, String prompt, String dataname, String parameterString) {
        super(gui,prompt);
        //else data=new NumericVariable("X", 0);
        setDataItemName(dataname);
        setTitle("Numeric Dataset settings");
        defaultvalueTextField=new JTextField(3);
        minTextField=new JTextField(3);
        maxTextField=new JTextField(3);
        baselineTextField=new JTextField(3);
        mainpanel=new JPanel();
        mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
        //mainpanel.add(valueTextField);
        messageLabel=new JLabel("  ");
        messageLabel.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
        messageLabel.setForeground(java.awt.Color.RED);
        useDataTrackRadioButton=new JRadioButton("DataTrack  ");
        useValuesRadioButton=new JRadioButton("Default value ");
        ButtonGroup group=new ButtonGroup();
        group.add(useDataTrackRadioButton);
        group.add(useValuesRadioButton);
        JPanel internPanel=new JPanel();
        internPanel.setLayout(new BoxLayout(internPanel, BoxLayout.Y_AXIS));
        JPanel tracksPanel=new JPanel(new FlowLayout(FlowLayout.LEFT));
        DataTrack[] trackslist=engine.getDataLoader().getAvailableDatatracks(NumericDataset.class);
        String[] tracksnames=new String[trackslist.length];
        for (int i=0;i<trackslist.length;i++) tracksnames[i]=trackslist[i].getName();
        datatracksCombobox=new JComboBox(tracksnames);
        tracksPanel.add(useDataTrackRadioButton);
        tracksPanel.add(datatracksCombobox);
        JPanel valuesPanel=new JPanel(new FlowLayout(FlowLayout.LEFT));
        valuesPanel.add(useValuesRadioButton);
        valuesPanel.add(defaultvalueTextField);
        valuesPanel.add(new JLabel("  Min "));
        valuesPanel.add(minTextField);
        valuesPanel.add(new JLabel("  Max "));
        valuesPanel.add(maxTextField);
        valuesPanel.add(new JLabel("  Baseline "));
        valuesPanel.add(baselineTextField);        
        internPanel.add(tracksPanel);
        internPanel.add(valuesPanel);
        mainpanel.add(internPanel);
        mainpanel.add(messageLabel);
        Dimension size=new Dimension(250,60);
        mainpanel.setMinimumSize(size);
        //mainpanel.setPreferredSize(size);
        setMainPanel(mainpanel);    
        minTextField.setText("0");
        maxTextField.setText("1");
        baselineTextField.setText("0");
        defaultvalueTextField.setText("0");
        if (parameterString==null || parameterString.isEmpty()) {
            useDataTrackRadioButton.setSelected(true);
        } else if (parameterString.startsWith(Operation_new.DATA_TRACK_PREFIX)) {
            useDataTrackRadioButton.setSelected(true);
            if (parameterString.length()>Operation_new.DATA_TRACK_PREFIX.length()) {
                String trackname=parameterString.substring(Operation_new.DATA_TRACK_PREFIX.length());
                datatracksCombobox.setSelectedItem(trackname);
            }
        } else {
            try {
               float[] values=Operation_new.parseMinMaxBaselineDefaultParameters(parameterString);
               minTextField.setText(""+values[0]);
               maxTextField.setText(""+values[1]);
               baselineTextField.setText(""+values[2]);
               defaultvalueTextField.setText(""+values[3]);          
            } catch (Exception e) {}  
            useValuesRadioButton.setSelected(true);
        }

        pack();
    }
    
    
    @Override
    public boolean onOKPressed() {
        float defaultvalue=0;
        float minvalue=0;
        float maxvalue=0;
        float baselinevalue=0;
        if (useValuesRadioButton.isSelected()) {
            try { defaultvalue=Float.parseFloat(defaultvalueTextField.getText().trim()); } 
            catch (NumberFormatException e) { 
                messageLabel.setText("Please enter a valid numeric default value"); return false;
            }
            try { minvalue=Float.parseFloat(minTextField.getText().trim()); } 
            catch (NumberFormatException e) { 
                messageLabel.setText("Please enter a valid numeric minimum value"); return false;
            }
            try { maxvalue=Float.parseFloat(maxTextField.getText().trim()); } 
            catch (NumberFormatException e) { 
                messageLabel.setText("Please enter a valid numeric maximum value"); return false;
            }
            try { baselinevalue=Float.parseFloat(baselineTextField.getText().trim()); } 
            catch (NumberFormatException e) { 
                messageLabel.setText("Please enter a valid numeric baseline value"); return false;
            }
            parameters="value="+defaultvalue+",min="+minvalue+",max="+maxvalue+",baseline="+baselinevalue;        
        } else {
            parameters=Operation_new.DATA_TRACK_PREFIX+(String)datatracksCombobox.getSelectedItem();
        }
        return true;
    }
    
    public Data getData() {
       return null; 
    }
    
    @Override
    public String getValueAsParameterString() {
        return parameters;
    }
}
