/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.prompt;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import priorseditor.engine.data.*;

import priorseditor.engine.PriorsEditorEngine;
import priorseditor.gui.PriorsEditorGUI;


/**
 *
 * @author kjetikl
 */
public class Prompt_NumericVariable extends Prompt {
    
    private JTextField valueTextField;
    private NumericVariable data;
    private JPanel mainpanel;
    private JLabel messageLabel;

    
    
    
    public Prompt_NumericVariable(PriorsEditorGUI gui, String prompt, NumericVariable dataitem) {
        super(gui,prompt);
        if (dataitem!=null) data=dataitem;
        else data=new NumericVariable(gui.getGenericDataitemName(NumericVariable.class, null), 0);
        setDataItemName(data.getName());
        setTitle("Numeric Variable");

        valueTextField=new JTextField(15);
        valueTextField.setText(data.getValue().toString());
        mainpanel=new JPanel();
        mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
        //mainpanel.add(valueTextField);
        messageLabel=new JLabel("  ");
        messageLabel.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
        messageLabel.setForeground(java.awt.Color.RED);
        JPanel internPanel=new JPanel();
        internPanel.setLayout(new BoxLayout(internPanel, BoxLayout.LINE_AXIS));
        JLabel valueLabel=new JLabel("Value");
        internPanel.add(valueLabel);
        internPanel.add(valueTextField);
        internPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 0, 5, 5));        
        mainpanel.add(internPanel);
        mainpanel.add(messageLabel);
        Dimension size=new Dimension(300,84);
        mainpanel.setMinimumSize(size);
        mainpanel.setPreferredSize(size);
        Dimension dim1=getDataNameLabelDimensions();
        valueLabel.setPreferredSize(dim1);
        valueLabel.setMaximumSize(dim1);
        valueLabel.setMinimumSize(dim1);
        Dimension dim2=getDataNameFieldDimensions();
        valueTextField.setPreferredSize(dim2);
        valueTextField.setMaximumSize(new Dimension(300,dim2.height));
        JPanel wrapper=new JPanel();
        wrapper.setLayout(new FlowLayout(FlowLayout.LEADING));
        wrapper.add(mainpanel);
        setMainPanel(wrapper);       
        pack();
    }
    
    
    @Override
    public boolean onOKPressed() {
        try {
            float value=Float.parseFloat(valueTextField.getText().trim());
            data.setValue(value);
        } catch (NumberFormatException e) {
            messageLabel.setText("Please enter a valid numeric value");
            return false;
        }
        String newName=getDataItemName();
        if (!data.getName().equals(newName)) data.rename(newName);        
        return true;
    }
    
    public Data getData() {
       return data; 
    }
    

}
