/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.prompt;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import priorseditor.engine.PriorsEditorEngine;
import priorseditor.engine.data.Data;
import priorseditor.engine.data.RegionDataset;
import priorseditor.engine.datatracks.DataTrack;
import priorseditor.engine.operations.Operation_new;
import priorseditor.gui.PriorsEditorGUI;

/**
 *
 * @author kjetikl
 */
public class Prompt_RegionDataset extends Prompt {
    
    private JPanel mainpanel;
    private JLabel messageLabel;
    private String parameters = "";
    private JComboBox datatracksCombobox;
    
    
    
    public Prompt_RegionDataset(PriorsEditorGUI gui, String prompt, String dataname, String parameterString) {
        super(gui,prompt);
        setDataItemName(dataname);
        setTitle("Regions Dataset settings");
        mainpanel=new JPanel();
        mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
        //mainpanel.add(valueTextField);
        messageLabel=new JLabel("  ");
        messageLabel.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
        messageLabel.setForeground(java.awt.Color.RED);
        JPanel internPanel=new JPanel();
        internPanel.setLayout(new BoxLayout(internPanel, BoxLayout.Y_AXIS));
        JPanel tracksPanel=new JPanel(new FlowLayout(FlowLayout.LEFT));
        DataTrack[] trackslist=engine.getDataLoader().getAvailableDatatracks(RegionDataset.class);
        String[] tracksnames=new String[trackslist.length];
        for (int i=0;i<trackslist.length;i++) tracksnames[i]=trackslist[i].getName();
        datatracksCombobox=new JComboBox(tracksnames);
        tracksPanel.add(new JLabel("DataTrack  "));
        tracksPanel.add(datatracksCombobox);      
        internPanel.add(tracksPanel);
        mainpanel.add(internPanel);
        mainpanel.add(messageLabel);
        Dimension size=new Dimension(250,60);
        mainpanel.setMinimumSize(size);
        //mainpanel.setPreferredSize(size);
        setMainPanel(mainpanel);    
        if (parameterString!=null && parameterString.startsWith(Operation_new.DATA_TRACK_PREFIX)) {
            if (parameterString.length()>Operation_new.DATA_TRACK_PREFIX.length()) {
                String trackname=parameterString.substring(Operation_new.DATA_TRACK_PREFIX.length());
                datatracksCombobox.setSelectedItem(trackname);
            }
        } else {}

        pack();
    }
    
    
    @Override
    public boolean onOKPressed() {
        parameters=Operation_new.DATA_TRACK_PREFIX+(String)datatracksCombobox.getSelectedItem();
        return true;
    }
    
    public Data getData() {
       return null; 
    }
    
    @Override
    public String getValueAsParameterString() {
        return parameters;
    }

}