/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.gui.prompt;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import priorseditor.engine.data.*;
import priorseditor.gui.PriorsEditorGUI;

/**
 *
 * @author kjetikl
 */
public class Prompt_StringCollection extends Prompt {
    
    private JTextArea valueTextField;
    private StringCollection data;
    private JPanel mainpanel;
    private JLabel messageLabel;
    
    
    public Prompt_StringCollection(PriorsEditorGUI gui, String prompt, StringCollection dataitem) {
        super(gui,prompt);
        if (dataitem!=null) data=dataitem;
        else data=new StringCollection(gui.getGenericDataitemName(StringCollection.class, null));
        setDataItemName(data.getName());
        setTitle("String Collection");
               
        String values="";
        for (String string:data.getAllStrings()) {
            values+=string+"\n";
        }
        valueTextField=new JTextArea(values.trim());
        mainpanel=new JPanel();
        mainpanel.setLayout(new BoxLayout(mainpanel, BoxLayout.Y_AXIS));
        messageLabel=new JLabel("  ");
        messageLabel.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
        messageLabel.setForeground(java.awt.Color.RED);
        JPanel internPanel=new JPanel();
        internPanel.setLayout(new BorderLayout());
        internPanel.add(new JScrollPane(valueTextField));
        mainpanel.add(internPanel);
        mainpanel.add(messageLabel);
        Dimension size=new Dimension(300,400);
        mainpanel.setMinimumSize(size);
        mainpanel.setPreferredSize(size);
        setMainPanel(mainpanel);        
        pack();
    }

   @Override
    public boolean onOKPressed() {
        String val = valueTextField.getText().trim();
        val=val.replaceAll("\n\\s*\n", "\n"); // remove empty lines
        if (val.trim().isEmpty()) { // no strings entered
            data.clearAll();
        } else {
            String list[] = val.split("\n");
            for (int i=0;i<list.length;i++) {
                list[i]=list[i].trim();
                if (!StringVariable.isValidValue(list[i])) {
                   messageLabel.setText("Invalid value:"+list[i]+" (string might contain illegal characters)");
                   return false;            
                }
            }
            data.setValue(list);
        }
        String newName=getDataItemName();
        if (!data.getName().equals(newName)) data.rename(newName);        
        return true;
    }
    
    @Override
    public Data getData() {
       return data; 
    }
    
}
