/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package priorseditor.engine.datatracks;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 *
 * @author kjetikl
 */
public class DASParser_DNA {
    SAXParserFactory factory;
    SAXParser saxParser;
    ElementParser handler;
    //char[] buffer=null;
    String buffer=null;
    int buffersize=0;
    boolean inside=true;
    int bufferpos=0;    

    
    public char[] parse(String uri, int timeout) throws Exception {
        //System.err.println("Parsing uri:"+uri);
        factory = SAXParserFactory.newInstance();
        saxParser = factory.newSAXParser();
        handler = new ElementParser();
        URL url=new URL(uri);
        URLConnection connection=url.openConnection();
        connection.setConnectTimeout(timeout);
        InputStream inputStream =connection.getInputStream();
        saxParser.parse(inputStream, handler);
        if (buffer.length()!=buffersize) throw new SAXException("Length of read DNA sequence ("+buffer.length()+" bp) does not match expected buffer size ("+buffersize+" bp)");
        return buffer.toUpperCase().toCharArray();
    } 
    
    
    /** Implements important methods in the callback interface for the SAX XML-reader*/
    private class ElementParser extends DefaultHandler {
        
        @Override
        public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
            super.startElement(uri, localName, qName, attributes);
            //System.err.println("-> Start:"+localName+","+qName);
            //for (int i=0;i<attributes.getLength();i++) {System.err.println("       "+attributes.getQName(i)+"="+attributes.getValue(i));}
            if (qName.equals("DNA")) {
                String stringVal=attributes.getValue("length");
                try {
                    buffersize=Integer.parseInt(stringVal);
                    buffer="";
                } catch (NumberFormatException e) {throw new SAXException("Unable to parse expected integer for DNA buffer length. Value="+stringVal);}
                inside=true;
                //bufferpos=0;
            }
        }
        
        @Override
        public void endElement(String uri, String localName, String qName) throws SAXException {
            super.endElement(uri, localName, qName);
            //System.err.println("<- End  :"+localName+","+qName);
            if (qName.equals("DNA")) {
                inside=false;
                buffer=buffer.replaceAll("\\s+", ""); // remove whitespace
            }
        }


        @Override
        public void characters(char[] ch, int start, int length) throws SAXException {
            super.characters(ch, start, length);
            if (inside && buffer!=null) {
                //System.err.println("Read "+length+" bp starting at "+start+" bufferpos="+bufferpos);
                buffer+=new String(ch, start, length);
                //bufferpos+=length;
                //System.err.println(buffer);
            }       
        }
        
        @Override
        public void fatalError(SAXParseException e) throws SAXException {
            super.fatalError(e);
        }
        
    } // end internal class ElementParser
    
    
}
